/* dirmenu.c generated by valac 0.56.17, the Vala compiler
 * generated from dirmenu.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "dirmenu.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "vala-panel.h"
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>

#define DIRMENU_DIR "dir-path"
#define DIRMENU_ICON "icon-name"
#define DIRMENU_LABEL "caption"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DIRMENU_0_PROPERTY,
	DIRMENU_DIR_PATH_PROPERTY,
	DIRMENU_CAPTION_PROPERTY,
	DIRMENU_ICON_NAME_PROPERTY,
	DIRMENU_NUM_PROPERTIES
};
static GParamSpec* dirmenu_properties[DIRMENU_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;

#define DIRMENU_TYPE_DIRECTORY_SORT (dirmenu_directory_sort_get_type ())
typedef struct _DirmenuDirectorySort DirmenuDirectorySort;
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block3Data Block3Data;
#define _dirmenu_directory_sort_free0(var) ((var == NULL) ? NULL : (var = (dirmenu_directory_sort_free (var), NULL)))

struct _DirmenuPrivate {
	gchar* _dir_path;
	gchar* _caption;
	gchar* _icon_name;
};

struct _Block1Data {
	int _ref_count_;
	Dirmenu* self;
	GtkMenuButton* button;
};

struct _Block2Data {
	int _ref_count_;
	Dirmenu* self;
	gchar* directory;
};

struct _DirmenuDirectorySort {
	gchar* dirname;
	gchar* collate_key;
};

struct _Block3Data {
	int _ref_count_;
	Block2Data * _data2_;
	GtkMenuItem* item;
};

static gint Dirmenu_private_offset;
static gpointer dirmenu_parent_class = NULL;
static GType dirmenu_type_id = 0;

static void dirmenu_real_constructed (GObject* base);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static GIcon* dirmenu_set_icon (Dirmenu* self);
VALA_EXTERN const gchar* dirmenu_get_caption (Dirmenu* self);
static GtkMenu* dirmenu_create_menu (Dirmenu* self,
                              const gchar* directory,
                              gboolean at_top);
VALA_EXTERN const gchar* dirmenu_get_dir_path (Dirmenu* self);
static void __lambda9_ (Block1Data* _data1_,
                 GParamSpec* pspec);
static void ___lambda9__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
VALA_EXTERN const gchar* dirmenu_get_icon_name (Dirmenu* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static GType dirmenu_directory_sort_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static DirmenuDirectorySort* dirmenu_directory_sort_dup (const DirmenuDirectorySort* self);
static void dirmenu_directory_sort_free (DirmenuDirectorySort* self);
static void dirmenu_directory_sort_copy (const DirmenuDirectorySort* self,
                                  DirmenuDirectorySort* dest);
static void dirmenu_directory_sort_destroy (DirmenuDirectorySort* self);
static gint ______lambda4_ (DirmenuDirectorySort* a,
                     DirmenuDirectorySort* b);
static gint _______lambda4__gcompare_func (gconstpointer a,
                                    gconstpointer b);
static void _dirmenu_directory_sort_free0_ (gpointer var);
static inline void _g_slist_free__dirmenu_directory_sort_free0_ (GSList* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void ____lambda5_ (Block3Data* _data3_);
static void _____lambda5__gtk_menu_item_select (GtkMenuItem* _sender,
                                         gpointer self);
static void ____lambda6_ (Block3Data* _data3_);
static void _____lambda6__gtk_menu_item_deselect (GtkMenuItem* _sender,
                                           gpointer self);
static void __lambda7_ (Block2Data* _data2_);
static void ___lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self);
static void __lambda8_ (Block2Data* _data2_);
static void dirmenu_launch_terminal (Dirmenu* self,
                              const gchar* dir);
static void ___lambda8__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self);
static gboolean dirmenu_real_button_release_event (GtkWidget* base,
                                            GdkEventButton* e);
static GtkWidget* dirmenu_real_get_settings_ui (ValaPanelApplet* base);
VALA_EXTERN void dirmenu_set_dir_path (Dirmenu* self,
                           const gchar* value);
VALA_EXTERN void dirmenu_set_caption (Dirmenu* self,
                          const gchar* value);
VALA_EXTERN void dirmenu_set_icon_name (Dirmenu* self,
                            const gchar* value);
static void dirmenu_finalize (GObject * obj);
static void _vala_dirmenu_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec);
static void _vala_dirmenu_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
dirmenu_get_instance_private (Dirmenu* self)
{
	return G_STRUCT_MEMBER_P (self, Dirmenu_private_offset);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 38 "../applets/core/dirmenu/dirmenu.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 38 "../applets/core/dirmenu/dirmenu.vala"
	return _data1_;
#line 185 "dirmenu.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 38 "../applets/core/dirmenu/dirmenu.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 195 "dirmenu.c"
		Dirmenu* self;
#line 38 "../applets/core/dirmenu/dirmenu.vala"
		self = _data1_->self;
#line 38 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (_data1_->button);
#line 38 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (self);
#line 38 "../applets/core/dirmenu/dirmenu.vala"
		g_slice_free (Block1Data, _data1_);
#line 205 "dirmenu.c"
	}
}

static void
__lambda9_ (Block1Data* _data1_,
            GParamSpec* pspec)
{
	Dirmenu* self;
	const gchar* _tmp0_;
	const gchar* _tmp5_;
	const gchar* _tmp7_;
#line 49 "../applets/core/dirmenu/dirmenu.vala"
	self = _data1_->self;
#line 49 "../applets/core/dirmenu/dirmenu.vala"
	g_return_if_fail (pspec != NULL);
#line 50 "../applets/core/dirmenu/dirmenu.vala"
	_tmp0_ = pspec->name;
#line 50 "../applets/core/dirmenu/dirmenu.vala"
	if (g_strcmp0 (_tmp0_, DIRMENU_ICON) == 0) {
#line 225 "dirmenu.c"
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		GIcon* _tmp3_;
		GIcon* _tmp4_;
#line 51 "../applets/core/dirmenu/dirmenu.vala"
		_tmp1_ = gtk_button_get_image ((GtkButton*) _data1_->button);
#line 51 "../applets/core/dirmenu/dirmenu.vala"
		_tmp2_ = _tmp1_;
#line 51 "../applets/core/dirmenu/dirmenu.vala"
		_tmp3_ = dirmenu_set_icon (self);
#line 51 "../applets/core/dirmenu/dirmenu.vala"
		_tmp4_ = _tmp3_;
#line 51 "../applets/core/dirmenu/dirmenu.vala"
		gtk_image_set_from_gicon (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_image_get_type ()) ? ((GtkImage*) _tmp2_) : NULL, _tmp4_, (GtkIconSize) GTK_ICON_SIZE_INVALID);
#line 51 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (_tmp4_);
#line 242 "dirmenu.c"
	}
#line 52 "../applets/core/dirmenu/dirmenu.vala"
	_tmp5_ = pspec->name;
#line 52 "../applets/core/dirmenu/dirmenu.vala"
	if (g_strcmp0 (_tmp5_, DIRMENU_LABEL) == 0) {
#line 248 "dirmenu.c"
		const gchar* _tmp6_;
#line 53 "../applets/core/dirmenu/dirmenu.vala"
		_tmp6_ = self->priv->_caption;
#line 53 "../applets/core/dirmenu/dirmenu.vala"
		gtk_button_set_label ((GtkButton*) _data1_->button, _tmp6_);
#line 254 "dirmenu.c"
	}
#line 54 "../applets/core/dirmenu/dirmenu.vala"
	_tmp7_ = pspec->name;
#line 54 "../applets/core/dirmenu/dirmenu.vala"
	if (g_strcmp0 (_tmp7_, DIRMENU_DIR) == 0) {
#line 260 "dirmenu.c"
		const gchar* _tmp8_;
		GtkMenu* _tmp9_;
		GtkMenu* _tmp10_;
#line 55 "../applets/core/dirmenu/dirmenu.vala"
		_tmp8_ = self->priv->_dir_path;
#line 55 "../applets/core/dirmenu/dirmenu.vala"
		_tmp9_ = dirmenu_create_menu (self, _tmp8_, FALSE);
#line 55 "../applets/core/dirmenu/dirmenu.vala"
		_tmp10_ = _tmp9_;
#line 55 "../applets/core/dirmenu/dirmenu.vala"
		gtk_menu_button_set_popup (_data1_->button, (GtkWidget*) _tmp10_);
#line 55 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (_tmp10_);
#line 274 "dirmenu.c"
	}
}

static void
___lambda9__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 49 "../applets/core/dirmenu/dirmenu.vala"
	__lambda9_ (self, pspec);
#line 285 "dirmenu.c"
}

static void
dirmenu_real_constructed (GObject* base)
{
	Dirmenu * self;
	Block1Data* _data1_;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GAction* _tmp2_;
	GtkMenuButton* _tmp3_;
	GtkImage* img = NULL;
	GtkImage* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GIcon* _tmp11_;
	GIcon* _tmp12_;
	ValaPanelToplevel* _tmp13_;
	ValaPanelToplevel* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GtkMenu* _tmp17_;
	GtkMenu* _tmp18_;
#line 38 "../applets/core/dirmenu/dirmenu.vala"
	self = (Dirmenu*) base;
#line 38 "../applets/core/dirmenu/dirmenu.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 38 "../applets/core/dirmenu/dirmenu.vala"
	_data1_->_ref_count_ = 1;
#line 38 "../applets/core/dirmenu/dirmenu.vala"
	_data1_->self = g_object_ref (self);
#line 40 "../applets/core/dirmenu/dirmenu.vala"
	_tmp0_ = vala_panel_applet_get_action_group ((ValaPanelApplet*) self);
#line 40 "../applets/core/dirmenu/dirmenu.vala"
	_tmp1_ = _tmp0_;
#line 40 "../applets/core/dirmenu/dirmenu.vala"
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) _tmp1_, VALA_PANEL_APPLET_ACTION_CONFIGURE);
#line 40 "../applets/core/dirmenu/dirmenu.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL, TRUE);
#line 41 "../applets/core/dirmenu/dirmenu.vala"
	_tmp3_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 41 "../applets/core/dirmenu/dirmenu.vala"
	g_object_ref_sink (_tmp3_);
#line 41 "../applets/core/dirmenu/dirmenu.vala"
	_data1_->button = _tmp3_;
#line 42 "../applets/core/dirmenu/dirmenu.vala"
	_tmp4_ = (GtkImage*) gtk_image_new ();
#line 42 "../applets/core/dirmenu/dirmenu.vala"
	g_object_ref_sink (_tmp4_);
#line 42 "../applets/core/dirmenu/dirmenu.vala"
	img = _tmp4_;
#line 43 "../applets/core/dirmenu/dirmenu.vala"
	_tmp5_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 43 "../applets/core/dirmenu/dirmenu.vala"
	_tmp6_ = _tmp5_;
#line 43 "../applets/core/dirmenu/dirmenu.vala"
	g_settings_bind (_tmp6_, DIRMENU_DIR, (GObject*) self, DIRMENU_DIR, G_SETTINGS_BIND_GET);
#line 44 "../applets/core/dirmenu/dirmenu.vala"
	_tmp7_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 44 "../applets/core/dirmenu/dirmenu.vala"
	_tmp8_ = _tmp7_;
#line 44 "../applets/core/dirmenu/dirmenu.vala"
	g_settings_bind (_tmp8_, DIRMENU_ICON, (GObject*) self, DIRMENU_ICON, G_SETTINGS_BIND_GET);
#line 45 "../applets/core/dirmenu/dirmenu.vala"
	_tmp9_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 45 "../applets/core/dirmenu/dirmenu.vala"
	_tmp10_ = _tmp9_;
#line 45 "../applets/core/dirmenu/dirmenu.vala"
	g_settings_bind (_tmp10_, DIRMENU_LABEL, (GObject*) self, DIRMENU_LABEL, G_SETTINGS_BIND_GET);
#line 46 "../applets/core/dirmenu/dirmenu.vala"
	_tmp11_ = dirmenu_set_icon (self);
#line 46 "../applets/core/dirmenu/dirmenu.vala"
	_tmp12_ = _tmp11_;
#line 46 "../applets/core/dirmenu/dirmenu.vala"
	_tmp13_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
#line 46 "../applets/core/dirmenu/dirmenu.vala"
	_tmp14_ = _tmp13_;
#line 46 "../applets/core/dirmenu/dirmenu.vala"
	vala_panel_setup_icon (img, _tmp12_, (GObject*) _tmp14_, -1);
#line 46 "../applets/core/dirmenu/dirmenu.vala"
	_g_object_unref0 (_tmp12_);
#line 47 "../applets/core/dirmenu/dirmenu.vala"
	_tmp15_ = self->priv->_caption;
#line 47 "../applets/core/dirmenu/dirmenu.vala"
	vala_panel_setup_button (G_TYPE_CHECK_INSTANCE_TYPE (_data1_->button, gtk_button_get_type ()) ? ((GtkButton*) _data1_->button) : NULL, img, _tmp15_);
#line 48 "../applets/core/dirmenu/dirmenu.vala"
	_tmp16_ = self->priv->_dir_path;
#line 48 "../applets/core/dirmenu/dirmenu.vala"
	_tmp17_ = dirmenu_create_menu (self, _tmp16_, FALSE);
#line 48 "../applets/core/dirmenu/dirmenu.vala"
	_tmp18_ = _tmp17_;
#line 48 "../applets/core/dirmenu/dirmenu.vala"
	gtk_menu_button_set_popup (_data1_->button, (GtkWidget*) _tmp18_);
#line 48 "../applets/core/dirmenu/dirmenu.vala"
	_g_object_unref0 (_tmp18_);
#line 49 "../applets/core/dirmenu/dirmenu.vala"
	g_signal_connect_data ((GObject*) self, "notify", (GCallback) ___lambda9__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 57 "../applets/core/dirmenu/dirmenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _data1_->button);
#line 58 "../applets/core/dirmenu/dirmenu.vala"
	gtk_widget_show ((GtkWidget*) _data1_->button);
#line 59 "../applets/core/dirmenu/dirmenu.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 38 "../applets/core/dirmenu/dirmenu.vala"
	_g_object_unref0 (img);
#line 38 "../applets/core/dirmenu/dirmenu.vala"
	block1_data_unref (_data1_);
#line 38 "../applets/core/dirmenu/dirmenu.vala"
	_data1_ = NULL;
#line 399 "dirmenu.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 67 "../applets/core/dirmenu/dirmenu.vala"
	return self ? g_object_ref (self) : NULL;
#line 407 "dirmenu.c"
}

static GIcon*
dirmenu_set_icon (Dirmenu* self)
{
	GIcon* icon = NULL;
	GIcon* _tmp4_ = NULL;
	GIcon* _tmp5_;
	GIcon* _tmp6_;
	GIcon* _tmp8_;
	GError* _inner_error0_ = NULL;
	GIcon* result;
#line 61 "../applets/core/dirmenu/dirmenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../applets/core/dirmenu/dirmenu.vala"
	icon = NULL;
#line 424 "dirmenu.c"
	{
		GIcon* _tmp0_ = NULL;
		const gchar* _tmp1_;
		GIcon* _tmp2_;
		GIcon* _tmp3_;
#line 65 "../applets/core/dirmenu/dirmenu.vala"
		_tmp1_ = self->priv->_icon_name;
#line 65 "../applets/core/dirmenu/dirmenu.vala"
		_tmp2_ = g_icon_new_for_string (_tmp1_, &_inner_error0_);
#line 65 "../applets/core/dirmenu/dirmenu.vala"
		_tmp0_ = _tmp2_;
#line 65 "../applets/core/dirmenu/dirmenu.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 438 "dirmenu.c"
			goto __catch0_g_error;
		}
#line 65 "../applets/core/dirmenu/dirmenu.vala"
		_tmp3_ = _tmp0_;
#line 65 "../applets/core/dirmenu/dirmenu.vala"
		_tmp0_ = NULL;
#line 65 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (icon);
#line 65 "../applets/core/dirmenu/dirmenu.vala"
		icon = _tmp3_;
#line 63 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (_tmp0_);
#line 451 "dirmenu.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 63 "../applets/core/dirmenu/dirmenu.vala"
		g_clear_error (&_inner_error0_);
#line 458 "dirmenu.c"
	}
	__finally0:
#line 63 "../applets/core/dirmenu/dirmenu.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 63 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (icon);
#line 63 "../applets/core/dirmenu/dirmenu.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 63 "../applets/core/dirmenu/dirmenu.vala"
		g_clear_error (&_inner_error0_);
#line 63 "../applets/core/dirmenu/dirmenu.vala"
		return NULL;
#line 471 "dirmenu.c"
	}
#line 67 "../applets/core/dirmenu/dirmenu.vala"
	_tmp5_ = icon;
#line 67 "../applets/core/dirmenu/dirmenu.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 67 "../applets/core/dirmenu/dirmenu.vala"
	_tmp4_ = _tmp6_;
#line 67 "../applets/core/dirmenu/dirmenu.vala"
	if (_tmp4_ == NULL) {
#line 481 "dirmenu.c"
		GThemedIcon* _tmp7_;
#line 67 "../applets/core/dirmenu/dirmenu.vala"
		_tmp7_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("system-file-manager");
#line 67 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (_tmp4_);
#line 67 "../applets/core/dirmenu/dirmenu.vala"
		_tmp4_ = (GIcon*) _tmp7_;
#line 489 "dirmenu.c"
	}
#line 67 "../applets/core/dirmenu/dirmenu.vala"
	_tmp8_ = _tmp4_;
#line 67 "../applets/core/dirmenu/dirmenu.vala"
	_tmp4_ = NULL;
#line 67 "../applets/core/dirmenu/dirmenu.vala"
	result = _tmp8_;
#line 67 "../applets/core/dirmenu/dirmenu.vala"
	_g_object_unref0 (_tmp4_);
#line 67 "../applets/core/dirmenu/dirmenu.vala"
	_g_object_unref0 (icon);
#line 67 "../applets/core/dirmenu/dirmenu.vala"
	return result;
#line 503 "dirmenu.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 69 "../applets/core/dirmenu/dirmenu.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 69 "../applets/core/dirmenu/dirmenu.vala"
	return _data2_;
#line 513 "dirmenu.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 69 "../applets/core/dirmenu/dirmenu.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 523 "dirmenu.c"
		Dirmenu* self;
#line 69 "../applets/core/dirmenu/dirmenu.vala"
		self = _data2_->self;
#line 69 "../applets/core/dirmenu/dirmenu.vala"
		_g_free0 (_data2_->directory);
#line 69 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (self);
#line 69 "../applets/core/dirmenu/dirmenu.vala"
		g_slice_free (Block2Data, _data2_);
#line 533 "dirmenu.c"
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 551 "dirmenu.c"
}

static gpointer
_dirmenu_directory_sort_dup0 (gpointer self)
{
#line 92 "../applets/core/dirmenu/dirmenu.vala"
	return self ? dirmenu_directory_sort_dup (self) : NULL;
#line 559 "dirmenu.c"
}

static gint
______lambda4_ (DirmenuDirectorySort* a,
                DirmenuDirectorySort* b)
{
	GCompareFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint result;
#line 92 "../applets/core/dirmenu/dirmenu.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 92 "../applets/core/dirmenu/dirmenu.vala"
	_tmp1_ = (*a).collate_key;
#line 92 "../applets/core/dirmenu/dirmenu.vala"
	_tmp2_ = (*b).collate_key;
#line 92 "../applets/core/dirmenu/dirmenu.vala"
	result = _tmp0_ (_tmp1_, _tmp2_);
#line 92 "../applets/core/dirmenu/dirmenu.vala"
	return result;
#line 580 "dirmenu.c"
}

static gint
_______lambda4__gcompare_func (gconstpointer a,
                               gconstpointer b)
{
	gint result;
	result = ______lambda4_ ((DirmenuDirectorySort*) a, (DirmenuDirectorySort*) b);
#line 92 "../applets/core/dirmenu/dirmenu.vala"
	return result;
#line 591 "dirmenu.c"
}

static void
_dirmenu_directory_sort_free0_ (gpointer var)
{
#line 78 "../applets/core/dirmenu/dirmenu.vala"
	(var == NULL) ? NULL : (var = (dirmenu_directory_sort_free (var), NULL));
#line 599 "dirmenu.c"
}

static inline void
_g_slist_free__dirmenu_directory_sort_free0_ (GSList* self)
{
#line 78 "../applets/core/dirmenu/dirmenu.vala"
	g_slist_free_full (self, (GDestroyNotify) _dirmenu_directory_sort_free0_);
#line 607 "dirmenu.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 98 "../applets/core/dirmenu/dirmenu.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 98 "../applets/core/dirmenu/dirmenu.vala"
	return _data3_;
#line 617 "dirmenu.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 98 "../applets/core/dirmenu/dirmenu.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 627 "dirmenu.c"
		Dirmenu* self;
#line 98 "../applets/core/dirmenu/dirmenu.vala"
		self = _data3_->_data2_->self;
#line 98 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (_data3_->item);
#line 98 "../applets/core/dirmenu/dirmenu.vala"
		block2_data_unref (_data3_->_data2_);
#line 98 "../applets/core/dirmenu/dirmenu.vala"
		_data3_->_data2_ = NULL;
#line 98 "../applets/core/dirmenu/dirmenu.vala"
		g_slice_free (Block3Data, _data3_);
#line 639 "dirmenu.c"
	}
}

static void
____lambda5_ (Block3Data* _data3_)
{
	Block2Data* _data2_;
	Dirmenu* self;
	GtkMenuItem* _tmp0_;
	GtkWidget* _tmp1_;
#line 119 "../applets/core/dirmenu/dirmenu.vala"
	_data2_ = _data3_->_data2_;
#line 119 "../applets/core/dirmenu/dirmenu.vala"
	self = _data2_->self;
#line 120 "../applets/core/dirmenu/dirmenu.vala"
	_tmp0_ = _data3_->item;
#line 120 "../applets/core/dirmenu/dirmenu.vala"
	_tmp1_ = gtk_menu_item_get_submenu (_tmp0_);
#line 120 "../applets/core/dirmenu/dirmenu.vala"
	if (_tmp1_ != NULL) {
#line 660 "dirmenu.c"
		gchar* dpath = NULL;
		GtkMenuItem* _tmp2_;
		GtkWidget* _tmp3_;
		gconstpointer _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
#line 123 "../applets/core/dirmenu/dirmenu.vala"
		_tmp2_ = _data3_->item;
#line 123 "../applets/core/dirmenu/dirmenu.vala"
		_tmp3_ = gtk_menu_item_get_submenu (_tmp2_);
#line 123 "../applets/core/dirmenu/dirmenu.vala"
		_tmp4_ = g_object_get_data ((GObject*) _tmp3_, "path");
#line 123 "../applets/core/dirmenu/dirmenu.vala"
		_tmp5_ = g_strdup ((const gchar*) _tmp4_);
#line 123 "../applets/core/dirmenu/dirmenu.vala"
		dpath = _tmp5_;
#line 124 "../applets/core/dirmenu/dirmenu.vala"
		_tmp6_ = dpath;
#line 124 "../applets/core/dirmenu/dirmenu.vala"
		if (_tmp6_ == NULL) {
#line 681 "dirmenu.c"
			GtkMenuItem* _tmp7_;
			GtkContainer* _tmp8_;
			gconstpointer _tmp9_;
			GtkMenuItem* _tmp10_;
			gconstpointer _tmp11_;
			gchar* _tmp12_;
			GtkMenuItem* _tmp13_;
			const gchar* _tmp14_;
			GtkMenu* _tmp15_;
			GtkMenu* _tmp16_;
#line 126 "../applets/core/dirmenu/dirmenu.vala"
			_tmp7_ = _data3_->item;
#line 126 "../applets/core/dirmenu/dirmenu.vala"
			_tmp8_ = gtk_widget_get_parent ((GtkWidget*) _tmp7_);
#line 126 "../applets/core/dirmenu/dirmenu.vala"
			_tmp9_ = g_object_get_data ((GObject*) _tmp8_, "path");
#line 126 "../applets/core/dirmenu/dirmenu.vala"
			_tmp10_ = _data3_->item;
#line 126 "../applets/core/dirmenu/dirmenu.vala"
			_tmp11_ = g_object_get_data ((GObject*) _tmp10_, "name");
#line 126 "../applets/core/dirmenu/dirmenu.vala"
			_tmp12_ = g_build_filename ((const gchar*) _tmp9_, (const gchar*) _tmp11_, NULL);
#line 126 "../applets/core/dirmenu/dirmenu.vala"
			_g_free0 (dpath);
#line 126 "../applets/core/dirmenu/dirmenu.vala"
			dpath = _tmp12_;
#line 129 "../applets/core/dirmenu/dirmenu.vala"
			_tmp13_ = _data3_->item;
#line 129 "../applets/core/dirmenu/dirmenu.vala"
			_tmp14_ = dpath;
#line 129 "../applets/core/dirmenu/dirmenu.vala"
			_tmp15_ = dirmenu_create_menu (self, _tmp14_, TRUE);
#line 129 "../applets/core/dirmenu/dirmenu.vala"
			_tmp16_ = _tmp15_;
#line 129 "../applets/core/dirmenu/dirmenu.vala"
			gtk_menu_item_set_submenu (_tmp13_, _tmp16_);
#line 129 "../applets/core/dirmenu/dirmenu.vala"
			_g_object_unref0 (_tmp16_);
#line 720 "dirmenu.c"
		}
#line 120 "../applets/core/dirmenu/dirmenu.vala"
		_g_free0 (dpath);
#line 724 "dirmenu.c"
	}
}

static void
_____lambda5__gtk_menu_item_select (GtkMenuItem* _sender,
                                    gpointer self)
{
#line 119 "../applets/core/dirmenu/dirmenu.vala"
	____lambda5_ (self);
#line 734 "dirmenu.c"
}

static void
____lambda6_ (Block3Data* _data3_)
{
	Block2Data* _data2_;
	Dirmenu* self;
	GtkMenuItem* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
#line 133 "../applets/core/dirmenu/dirmenu.vala"
	_data2_ = _data3_->_data2_;
#line 133 "../applets/core/dirmenu/dirmenu.vala"
	self = _data2_->self;
#line 133 "../applets/core/dirmenu/dirmenu.vala"
	_tmp0_ = _data3_->item;
#line 133 "../applets/core/dirmenu/dirmenu.vala"
	_tmp1_ = (GtkMenu*) gtk_menu_new ();
#line 133 "../applets/core/dirmenu/dirmenu.vala"
	g_object_ref_sink (_tmp1_);
#line 133 "../applets/core/dirmenu/dirmenu.vala"
	_tmp2_ = _tmp1_;
#line 133 "../applets/core/dirmenu/dirmenu.vala"
	gtk_menu_item_set_submenu (_tmp0_, _tmp2_);
#line 133 "../applets/core/dirmenu/dirmenu.vala"
	_g_object_unref0 (_tmp2_);
#line 761 "dirmenu.c"
}

static void
_____lambda6__gtk_menu_item_deselect (GtkMenuItem* _sender,
                                      gpointer self)
{
#line 133 "../applets/core/dirmenu/dirmenu.vala"
	____lambda6_ (self);
#line 770 "dirmenu.c"
}

static void
__lambda7_ (Block2Data* _data2_)
{
	Dirmenu* self;
	GError* _inner_error0_ = NULL;
#line 137 "../applets/core/dirmenu/dirmenu.vala"
	self = _data2_->self;
#line 780 "dirmenu.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		GdkDisplay* _tmp2_;
		GdkAppLaunchContext* _tmp3_;
		GdkAppLaunchContext* _tmp4_;
#line 139 "../applets/core/dirmenu/dirmenu.vala"
		_tmp1_ = g_filename_to_uri (_data2_->directory, NULL, &_inner_error0_);
#line 139 "../applets/core/dirmenu/dirmenu.vala"
		_tmp0_ = _tmp1_;
#line 139 "../applets/core/dirmenu/dirmenu.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 793 "dirmenu.c"
			goto __catch0_g_error;
		}
#line 139 "../applets/core/dirmenu/dirmenu.vala"
		_tmp2_ = gdk_display_get_default ();
#line 139 "../applets/core/dirmenu/dirmenu.vala"
		_tmp3_ = gdk_display_get_app_launch_context (_tmp2_);
#line 139 "../applets/core/dirmenu/dirmenu.vala"
		_tmp4_ = _tmp3_;
#line 139 "../applets/core/dirmenu/dirmenu.vala"
		g_app_info_launch_default_for_uri (_tmp0_, (GAppLaunchContext*) _tmp4_, &_inner_error0_);
#line 139 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (_tmp4_);
#line 139 "../applets/core/dirmenu/dirmenu.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "../applets/core/dirmenu/dirmenu.vala"
			_g_free0 (_tmp0_);
#line 810 "dirmenu.c"
			goto __catch0_g_error;
		}
#line 138 "../applets/core/dirmenu/dirmenu.vala"
		_g_free0 (_tmp0_);
#line 815 "dirmenu.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 138 "../applets/core/dirmenu/dirmenu.vala"
		e = _inner_error0_;
#line 138 "../applets/core/dirmenu/dirmenu.vala"
		_inner_error0_ = NULL;
#line 141 "../applets/core/dirmenu/dirmenu.vala"
		_tmp5_ = stderr;
#line 141 "../applets/core/dirmenu/dirmenu.vala"
		_tmp6_ = e;
#line 141 "../applets/core/dirmenu/dirmenu.vala"
		_tmp7_ = _tmp6_->message;
#line 141 "../applets/core/dirmenu/dirmenu.vala"
		fprintf (_tmp5_, "%s", _tmp7_);
#line 138 "../applets/core/dirmenu/dirmenu.vala"
		_g_error_free0 (e);
#line 838 "dirmenu.c"
	}
	__finally0:
#line 138 "../applets/core/dirmenu/dirmenu.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "../applets/core/dirmenu/dirmenu.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 138 "../applets/core/dirmenu/dirmenu.vala"
		g_clear_error (&_inner_error0_);
#line 138 "../applets/core/dirmenu/dirmenu.vala"
		return;
#line 849 "dirmenu.c"
	}
}

static void
___lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                    gpointer self)
{
#line 137 "../applets/core/dirmenu/dirmenu.vala"
	__lambda7_ (self);
#line 859 "dirmenu.c"
}

static void
__lambda8_ (Block2Data* _data2_)
{
	Dirmenu* self;
#line 145 "../applets/core/dirmenu/dirmenu.vala"
	self = _data2_->self;
#line 145 "../applets/core/dirmenu/dirmenu.vala"
	dirmenu_launch_terminal (self, _data2_->directory);
#line 870 "dirmenu.c"
}

static void
___lambda8__gtk_menu_item_activate (GtkMenuItem* _sender,
                                    gpointer self)
{
#line 145 "../applets/core/dirmenu/dirmenu.vala"
	__lambda8_ (self);
#line 879 "dirmenu.c"
}

static GtkMenu*
dirmenu_create_menu (Dirmenu* self,
                     const gchar* directory,
                     gboolean at_top)
{
	Block2Data* _data2_;
	gchar* _tmp0_;
	GtkMenu* menu = NULL;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	gchar* _tmp3_;
	GSList* dir_list = NULL;
	GDir* dir = NULL;
	GSList* _tmp26_;
	GtkMenuItem* item = NULL;
	GtkMenuItem* _tmp58_;
	GtkMenuItem* _tmp59_;
	GtkMenuItem* _tmp60_;
	GtkMenuItem* term = NULL;
	GtkMenuItem* _tmp61_;
	GtkMenuItem* _tmp62_;
	GtkMenuItem* _tmp63_;
	GtkMenu* _tmp78_;
	GError* _inner_error0_ = NULL;
	GtkMenu* result;
#line 69 "../applets/core/dirmenu/dirmenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../applets/core/dirmenu/dirmenu.vala"
	g_return_val_if_fail (directory != NULL, NULL);
#line 69 "../applets/core/dirmenu/dirmenu.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 69 "../applets/core/dirmenu/dirmenu.vala"
	_data2_->_ref_count_ = 1;
#line 69 "../applets/core/dirmenu/dirmenu.vala"
	_data2_->self = g_object_ref (self);
#line 69 "../applets/core/dirmenu/dirmenu.vala"
	_tmp0_ = g_strdup (directory);
#line 69 "../applets/core/dirmenu/dirmenu.vala"
	_g_free0 (_data2_->directory);
#line 69 "../applets/core/dirmenu/dirmenu.vala"
	_data2_->directory = _tmp0_;
#line 72 "../applets/core/dirmenu/dirmenu.vala"
	_tmp1_ = (GtkMenu*) gtk_menu_new ();
#line 72 "../applets/core/dirmenu/dirmenu.vala"
	g_object_ref_sink (_tmp1_);
#line 72 "../applets/core/dirmenu/dirmenu.vala"
	menu = _tmp1_;
#line 73 "../applets/core/dirmenu/dirmenu.vala"
	_tmp2_ = menu;
#line 73 "../applets/core/dirmenu/dirmenu.vala"
	_tmp3_ = g_strdup (_data2_->directory);
#line 73 "../applets/core/dirmenu/dirmenu.vala"
	g_object_set_data_full ((GObject*) _tmp2_, "path", _tmp3_, g_free);
#line 74 "../applets/core/dirmenu/dirmenu.vala"
	dir_list = NULL;
#line 77 "../applets/core/dirmenu/dirmenu.vala"
	dir = NULL;
#line 939 "dirmenu.c"
	{
		GDir* _tmp4_ = NULL;
		GDir* _tmp5_;
		GDir* _tmp6_;
		gchar* name = NULL;
#line 79 "../applets/core/dirmenu/dirmenu.vala"
		_tmp5_ = g_dir_open (_data2_->directory, (guint) 0, &_inner_error0_);
#line 79 "../applets/core/dirmenu/dirmenu.vala"
		_tmp4_ = _tmp5_;
#line 79 "../applets/core/dirmenu/dirmenu.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 951 "dirmenu.c"
			goto __catch0_g_error;
		}
#line 79 "../applets/core/dirmenu/dirmenu.vala"
		_tmp6_ = _tmp4_;
#line 79 "../applets/core/dirmenu/dirmenu.vala"
		_tmp4_ = NULL;
#line 79 "../applets/core/dirmenu/dirmenu.vala"
		_g_dir_close0 (dir);
#line 79 "../applets/core/dirmenu/dirmenu.vala"
		dir = _tmp6_;
#line 80 "../applets/core/dirmenu/dirmenu.vala"
		name = NULL;
#line 81 "../applets/core/dirmenu/dirmenu.vala"
		while (TRUE) {
#line 966 "dirmenu.c"
			GDir* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
#line 81 "../applets/core/dirmenu/dirmenu.vala"
			_tmp7_ = dir;
#line 81 "../applets/core/dirmenu/dirmenu.vala"
			_tmp8_ = g_dir_read_name (_tmp7_);
#line 81 "../applets/core/dirmenu/dirmenu.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 81 "../applets/core/dirmenu/dirmenu.vala"
			_g_free0 (name);
#line 81 "../applets/core/dirmenu/dirmenu.vala"
			name = _tmp9_;
#line 81 "../applets/core/dirmenu/dirmenu.vala"
			_tmp10_ = name;
#line 81 "../applets/core/dirmenu/dirmenu.vala"
			if (!(_tmp10_ != NULL)) {
#line 81 "../applets/core/dirmenu/dirmenu.vala"
				break;
#line 988 "dirmenu.c"
			}
#line 84 "../applets/core/dirmenu/dirmenu.vala"
			_tmp11_ = name;
#line 84 "../applets/core/dirmenu/dirmenu.vala"
			if (string_get (_tmp11_, (glong) 0) != '.') {
#line 994 "dirmenu.c"
				gchar* full = NULL;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
#line 86 "../applets/core/dirmenu/dirmenu.vala"
				_tmp12_ = name;
#line 86 "../applets/core/dirmenu/dirmenu.vala"
				_tmp13_ = g_build_filename (_data2_->directory, _tmp12_, NULL);
#line 86 "../applets/core/dirmenu/dirmenu.vala"
				full = _tmp13_;
#line 87 "../applets/core/dirmenu/dirmenu.vala"
				_tmp14_ = full;
#line 87 "../applets/core/dirmenu/dirmenu.vala"
				if (g_file_test (_tmp14_, G_FILE_TEST_IS_DIR)) {
#line 1009 "dirmenu.c"
					DirmenuDirectorySort cur = {0};
					const gchar* _tmp15_;
					gchar* _tmp16_;
					DirmenuDirectorySort _tmp17_;
					const gchar* _tmp18_;
					gchar* _tmp19_;
					DirmenuDirectorySort _tmp20_;
					DirmenuDirectorySort _tmp21_;
					DirmenuDirectorySort* _tmp22_;
#line 89 "../applets/core/dirmenu/dirmenu.vala"
					memset (&cur, 0, sizeof (DirmenuDirectorySort));
#line 90 "../applets/core/dirmenu/dirmenu.vala"
					_tmp15_ = name;
#line 90 "../applets/core/dirmenu/dirmenu.vala"
					_tmp16_ = g_filename_display_name (_tmp15_);
#line 90 "../applets/core/dirmenu/dirmenu.vala"
					_g_free0 (cur.dirname);
#line 90 "../applets/core/dirmenu/dirmenu.vala"
					cur.dirname = _tmp16_;
#line 91 "../applets/core/dirmenu/dirmenu.vala"
					_tmp17_ = cur;
#line 91 "../applets/core/dirmenu/dirmenu.vala"
					_tmp18_ = _tmp17_.dirname;
#line 91 "../applets/core/dirmenu/dirmenu.vala"
					_tmp19_ = g_utf8_collate_key (_tmp18_, (gssize) -1);
#line 91 "../applets/core/dirmenu/dirmenu.vala"
					_g_free0 (cur.collate_key);
#line 91 "../applets/core/dirmenu/dirmenu.vala"
					cur.collate_key = _tmp19_;
#line 92 "../applets/core/dirmenu/dirmenu.vala"
					_tmp20_ = cur;
#line 92 "../applets/core/dirmenu/dirmenu.vala"
					_tmp21_ = _tmp20_;
#line 92 "../applets/core/dirmenu/dirmenu.vala"
					_tmp22_ = _dirmenu_directory_sort_dup0 (&_tmp21_);
#line 92 "../applets/core/dirmenu/dirmenu.vala"
					dir_list = g_slist_insert_sorted (dir_list, _tmp22_, _______lambda4__gcompare_func);
#line 87 "../applets/core/dirmenu/dirmenu.vala"
					dirmenu_directory_sort_destroy (&cur);
#line 1049 "dirmenu.c"
				}
#line 84 "../applets/core/dirmenu/dirmenu.vala"
				_g_free0 (full);
#line 1053 "dirmenu.c"
			}
		}
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		_g_free0 (name);
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		_g_dir_close0 (_tmp4_);
#line 1060 "dirmenu.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp23_;
		GError* _tmp24_;
		const gchar* _tmp25_;
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		e = _inner_error0_;
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		_inner_error0_ = NULL;
#line 96 "../applets/core/dirmenu/dirmenu.vala"
		_tmp23_ = stderr;
#line 96 "../applets/core/dirmenu/dirmenu.vala"
		_tmp24_ = e;
#line 96 "../applets/core/dirmenu/dirmenu.vala"
		_tmp25_ = _tmp24_->message;
#line 96 "../applets/core/dirmenu/dirmenu.vala"
		fprintf (_tmp23_, "%s\n", _tmp25_);
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		_g_error_free0 (e);
#line 1083 "dirmenu.c"
	}
	__finally0:
#line 78 "../applets/core/dirmenu/dirmenu.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		_g_dir_close0 (dir);
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		(dir_list == NULL) ? NULL : (dir_list = (_g_slist_free__dirmenu_directory_sort_free0_ (dir_list), NULL));
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (menu);
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		block2_data_unref (_data2_);
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		_data2_ = NULL;
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		g_clear_error (&_inner_error0_);
#line 78 "../applets/core/dirmenu/dirmenu.vala"
		return NULL;
#line 1104 "dirmenu.c"
	}
#line 98 "../applets/core/dirmenu/dirmenu.vala"
	_tmp26_ = dir_list;
#line 1108 "dirmenu.c"
	{
		GSList* cursor_collection = NULL;
		GSList* cursor_it = NULL;
#line 98 "../applets/core/dirmenu/dirmenu.vala"
		cursor_collection = _tmp26_;
#line 98 "../applets/core/dirmenu/dirmenu.vala"
		for (cursor_it = cursor_collection; cursor_it != NULL; cursor_it = cursor_it->next) {
#line 1116 "dirmenu.c"
			DirmenuDirectorySort* _tmp27_;
			DirmenuDirectorySort* cursor = NULL;
#line 98 "../applets/core/dirmenu/dirmenu.vala"
			_tmp27_ = _dirmenu_directory_sort_dup0 ((DirmenuDirectorySort*) cursor_it->data);
#line 98 "../applets/core/dirmenu/dirmenu.vala"
			cursor = _tmp27_;
#line 1123 "dirmenu.c"
			{
				Block3Data* _data3_;
				GtkMenuItem* _tmp28_;
				GtkBox* box = NULL;
				GtkBox* _tmp29_;
				GtkImage* img = NULL;
				GThemedIcon* _tmp30_;
				GThemedIcon* _tmp31_;
				GtkImage* _tmp32_;
				GtkImage* _tmp33_;
				GtkImage* _tmp34_;
				GtkBox* _tmp35_;
				GtkImage* _tmp36_;
				GtkLabel* lbl = NULL;
				DirmenuDirectorySort* _tmp37_;
				const gchar* _tmp38_;
				GtkLabel* _tmp39_;
				GtkBox* _tmp40_;
				GtkLabel* _tmp41_;
				GtkLabel* _tmp42_;
				GtkMenuItem* _tmp43_;
				GtkBox* _tmp44_;
				GtkBox* _tmp45_;
				GtkMenu* dummy = NULL;
				GtkMenu* _tmp46_;
				GtkMenuItem* _tmp47_;
				GtkMenu* _tmp48_;
				GtkMenuItem* _tmp49_;
				GtkMenu* _tmp50_;
				GtkMenuItem* _tmp51_;
				GtkMenuItem* _tmp52_;
				DirmenuDirectorySort* _tmp53_;
				const gchar* _tmp54_;
				gchar* _tmp55_;
				GtkMenuItem* _tmp56_;
				GtkMenuItem* _tmp57_;
#line 98 "../applets/core/dirmenu/dirmenu.vala"
				_data3_ = g_slice_new0 (Block3Data);
#line 98 "../applets/core/dirmenu/dirmenu.vala"
				_data3_->_ref_count_ = 1;
#line 98 "../applets/core/dirmenu/dirmenu.vala"
				_data3_->_data2_ = block2_data_ref (_data2_);
#line 101 "../applets/core/dirmenu/dirmenu.vala"
				_tmp28_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 101 "../applets/core/dirmenu/dirmenu.vala"
				g_object_ref_sink (_tmp28_);
#line 101 "../applets/core/dirmenu/dirmenu.vala"
				_data3_->item = _tmp28_;
#line 102 "../applets/core/dirmenu/dirmenu.vala"
				_tmp29_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 10);
#line 102 "../applets/core/dirmenu/dirmenu.vala"
				g_object_ref_sink (_tmp29_);
#line 102 "../applets/core/dirmenu/dirmenu.vala"
				box = _tmp29_;
#line 103 "../applets/core/dirmenu/dirmenu.vala"
				_tmp30_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("folder-symbolic");
#line 103 "../applets/core/dirmenu/dirmenu.vala"
				_tmp31_ = _tmp30_;
#line 103 "../applets/core/dirmenu/dirmenu.vala"
				_tmp32_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp31_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 103 "../applets/core/dirmenu/dirmenu.vala"
				g_object_ref_sink (_tmp32_);
#line 103 "../applets/core/dirmenu/dirmenu.vala"
				_tmp33_ = _tmp32_;
#line 103 "../applets/core/dirmenu/dirmenu.vala"
				_g_object_unref0 (_tmp31_);
#line 103 "../applets/core/dirmenu/dirmenu.vala"
				img = _tmp33_;
#line 104 "../applets/core/dirmenu/dirmenu.vala"
				_tmp34_ = img;
#line 104 "../applets/core/dirmenu/dirmenu.vala"
				gtk_widget_show ((GtkWidget*) _tmp34_);
#line 105 "../applets/core/dirmenu/dirmenu.vala"
				_tmp35_ = box;
#line 105 "../applets/core/dirmenu/dirmenu.vala"
				_tmp36_ = img;
#line 105 "../applets/core/dirmenu/dirmenu.vala"
				gtk_box_pack_start (_tmp35_, (GtkWidget*) _tmp36_, FALSE, TRUE, (guint) 0);
#line 106 "../applets/core/dirmenu/dirmenu.vala"
				_tmp37_ = cursor;
#line 106 "../applets/core/dirmenu/dirmenu.vala"
				_tmp38_ = (*_tmp37_).dirname;
#line 106 "../applets/core/dirmenu/dirmenu.vala"
				_tmp39_ = (GtkLabel*) gtk_label_new (_tmp38_);
#line 106 "../applets/core/dirmenu/dirmenu.vala"
				g_object_ref_sink (_tmp39_);
#line 106 "../applets/core/dirmenu/dirmenu.vala"
				lbl = _tmp39_;
#line 107 "../applets/core/dirmenu/dirmenu.vala"
				_tmp40_ = box;
#line 107 "../applets/core/dirmenu/dirmenu.vala"
				_tmp41_ = lbl;
#line 107 "../applets/core/dirmenu/dirmenu.vala"
				gtk_box_pack_start (_tmp40_, (GtkWidget*) _tmp41_, FALSE, TRUE, (guint) 0);
#line 108 "../applets/core/dirmenu/dirmenu.vala"
				_tmp42_ = lbl;
#line 108 "../applets/core/dirmenu/dirmenu.vala"
				gtk_widget_show ((GtkWidget*) _tmp42_);
#line 109 "../applets/core/dirmenu/dirmenu.vala"
				_tmp43_ = _data3_->item;
#line 109 "../applets/core/dirmenu/dirmenu.vala"
				_tmp44_ = box;
#line 109 "../applets/core/dirmenu/dirmenu.vala"
				gtk_container_add ((GtkContainer*) _tmp43_, (GtkWidget*) _tmp44_);
#line 110 "../applets/core/dirmenu/dirmenu.vala"
				_tmp45_ = box;
#line 110 "../applets/core/dirmenu/dirmenu.vala"
				gtk_widget_show ((GtkWidget*) _tmp45_);
#line 111 "../applets/core/dirmenu/dirmenu.vala"
				_tmp46_ = (GtkMenu*) gtk_menu_new ();
#line 111 "../applets/core/dirmenu/dirmenu.vala"
				g_object_ref_sink (_tmp46_);
#line 111 "../applets/core/dirmenu/dirmenu.vala"
				dummy = _tmp46_;
#line 112 "../applets/core/dirmenu/dirmenu.vala"
				_tmp47_ = _data3_->item;
#line 112 "../applets/core/dirmenu/dirmenu.vala"
				_tmp48_ = dummy;
#line 112 "../applets/core/dirmenu/dirmenu.vala"
				gtk_menu_item_set_submenu (_tmp47_, _tmp48_);
#line 113 "../applets/core/dirmenu/dirmenu.vala"
				_tmp49_ = _data3_->item;
#line 113 "../applets/core/dirmenu/dirmenu.vala"
				gtk_widget_show ((GtkWidget*) _tmp49_);
#line 114 "../applets/core/dirmenu/dirmenu.vala"
				_tmp50_ = menu;
#line 114 "../applets/core/dirmenu/dirmenu.vala"
				_tmp51_ = _data3_->item;
#line 114 "../applets/core/dirmenu/dirmenu.vala"
				gtk_menu_shell_append ((GtkMenuShell*) _tmp50_, _tmp51_);
#line 117 "../applets/core/dirmenu/dirmenu.vala"
				_tmp52_ = _data3_->item;
#line 117 "../applets/core/dirmenu/dirmenu.vala"
				_tmp53_ = cursor;
#line 117 "../applets/core/dirmenu/dirmenu.vala"
				_tmp54_ = (*_tmp53_).dirname;
#line 117 "../applets/core/dirmenu/dirmenu.vala"
				_tmp55_ = g_strdup (_tmp54_);
#line 117 "../applets/core/dirmenu/dirmenu.vala"
				g_object_set_data_full ((GObject*) _tmp52_, "name", _tmp55_, g_free);
#line 119 "../applets/core/dirmenu/dirmenu.vala"
				_tmp56_ = _data3_->item;
#line 119 "../applets/core/dirmenu/dirmenu.vala"
				g_signal_connect_data (_tmp56_, "select", (GCallback) _____lambda5__gtk_menu_item_select, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 133 "../applets/core/dirmenu/dirmenu.vala"
				_tmp57_ = _data3_->item;
#line 133 "../applets/core/dirmenu/dirmenu.vala"
				g_signal_connect_data (_tmp57_, "deselect", (GCallback) _____lambda6__gtk_menu_item_deselect, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 98 "../applets/core/dirmenu/dirmenu.vala"
				_g_object_unref0 (dummy);
#line 98 "../applets/core/dirmenu/dirmenu.vala"
				_g_object_unref0 (lbl);
#line 98 "../applets/core/dirmenu/dirmenu.vala"
				_g_object_unref0 (img);
#line 98 "../applets/core/dirmenu/dirmenu.vala"
				_g_object_unref0 (box);
#line 98 "../applets/core/dirmenu/dirmenu.vala"
				_dirmenu_directory_sort_free0 (cursor);
#line 98 "../applets/core/dirmenu/dirmenu.vala"
				block3_data_unref (_data3_);
#line 98 "../applets/core/dirmenu/dirmenu.vala"
				_data3_ = NULL;
#line 1286 "dirmenu.c"
			}
		}
	}
#line 136 "../applets/core/dirmenu/dirmenu.vala"
	_tmp58_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("_Open"));
#line 136 "../applets/core/dirmenu/dirmenu.vala"
	g_object_ref_sink (_tmp58_);
#line 136 "../applets/core/dirmenu/dirmenu.vala"
	item = _tmp58_;
#line 137 "../applets/core/dirmenu/dirmenu.vala"
	_tmp59_ = item;
#line 137 "../applets/core/dirmenu/dirmenu.vala"
	g_signal_connect_data (_tmp59_, "activate", (GCallback) ___lambda7__gtk_menu_item_activate, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 143 "../applets/core/dirmenu/dirmenu.vala"
	_tmp60_ = item;
#line 143 "../applets/core/dirmenu/dirmenu.vala"
	gtk_widget_show ((GtkWidget*) _tmp60_);
#line 144 "../applets/core/dirmenu/dirmenu.vala"
	_tmp61_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic (_ ("Open in _Terminal"));
#line 144 "../applets/core/dirmenu/dirmenu.vala"
	g_object_ref_sink (_tmp61_);
#line 144 "../applets/core/dirmenu/dirmenu.vala"
	term = _tmp61_;
#line 145 "../applets/core/dirmenu/dirmenu.vala"
	_tmp62_ = term;
#line 145 "../applets/core/dirmenu/dirmenu.vala"
	g_signal_connect_data (_tmp62_, "activate", (GCallback) ___lambda8__gtk_menu_item_activate, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 146 "../applets/core/dirmenu/dirmenu.vala"
	_tmp63_ = term;
#line 146 "../applets/core/dirmenu/dirmenu.vala"
	gtk_widget_show ((GtkWidget*) _tmp63_);
#line 149 "../applets/core/dirmenu/dirmenu.vala"
	if (at_top) {
#line 1320 "dirmenu.c"
		GtkMenu* _tmp64_;
		GtkSeparatorMenuItem* _tmp65_;
		GtkSeparatorMenuItem* _tmp66_;
		GtkMenu* _tmp67_;
		GtkMenuItem* _tmp68_;
		GtkMenu* _tmp69_;
		GtkMenuItem* _tmp70_;
#line 151 "../applets/core/dirmenu/dirmenu.vala"
		_tmp64_ = menu;
#line 151 "../applets/core/dirmenu/dirmenu.vala"
		_tmp65_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 151 "../applets/core/dirmenu/dirmenu.vala"
		g_object_ref_sink (_tmp65_);
#line 151 "../applets/core/dirmenu/dirmenu.vala"
		_tmp66_ = _tmp65_;
#line 151 "../applets/core/dirmenu/dirmenu.vala"
		gtk_menu_shell_insert ((GtkMenuShell*) _tmp64_, (GtkWidget*) _tmp66_, 0);
#line 151 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (_tmp66_);
#line 152 "../applets/core/dirmenu/dirmenu.vala"
		_tmp67_ = menu;
#line 152 "../applets/core/dirmenu/dirmenu.vala"
		_tmp68_ = term;
#line 152 "../applets/core/dirmenu/dirmenu.vala"
		gtk_menu_shell_insert ((GtkMenuShell*) _tmp67_, (GtkWidget*) _tmp68_, 0);
#line 153 "../applets/core/dirmenu/dirmenu.vala"
		_tmp69_ = menu;
#line 153 "../applets/core/dirmenu/dirmenu.vala"
		_tmp70_ = item;
#line 153 "../applets/core/dirmenu/dirmenu.vala"
		gtk_menu_shell_insert ((GtkMenuShell*) _tmp69_, (GtkWidget*) _tmp70_, 0);
#line 1352 "dirmenu.c"
	} else {
		GtkMenu* _tmp71_;
		GtkSeparatorMenuItem* _tmp72_;
		GtkSeparatorMenuItem* _tmp73_;
		GtkMenu* _tmp74_;
		GtkMenuItem* _tmp75_;
		GtkMenu* _tmp76_;
		GtkMenuItem* _tmp77_;
#line 156 "../applets/core/dirmenu/dirmenu.vala"
		_tmp71_ = menu;
#line 156 "../applets/core/dirmenu/dirmenu.vala"
		_tmp72_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 156 "../applets/core/dirmenu/dirmenu.vala"
		g_object_ref_sink (_tmp72_);
#line 156 "../applets/core/dirmenu/dirmenu.vala"
		_tmp73_ = _tmp72_;
#line 156 "../applets/core/dirmenu/dirmenu.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp71_, (GtkMenuItem*) _tmp73_);
#line 156 "../applets/core/dirmenu/dirmenu.vala"
		_g_object_unref0 (_tmp73_);
#line 157 "../applets/core/dirmenu/dirmenu.vala"
		_tmp74_ = menu;
#line 157 "../applets/core/dirmenu/dirmenu.vala"
		_tmp75_ = term;
#line 157 "../applets/core/dirmenu/dirmenu.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp74_, _tmp75_);
#line 158 "../applets/core/dirmenu/dirmenu.vala"
		_tmp76_ = menu;
#line 158 "../applets/core/dirmenu/dirmenu.vala"
		_tmp77_ = item;
#line 158 "../applets/core/dirmenu/dirmenu.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp76_, _tmp77_);
#line 1385 "dirmenu.c"
	}
#line 162 "../applets/core/dirmenu/dirmenu.vala"
	_tmp78_ = menu;
#line 162 "../applets/core/dirmenu/dirmenu.vala"
	gtk_widget_show ((GtkWidget*) _tmp78_);
#line 163 "../applets/core/dirmenu/dirmenu.vala"
	result = menu;
#line 163 "../applets/core/dirmenu/dirmenu.vala"
	_g_object_unref0 (term);
#line 163 "../applets/core/dirmenu/dirmenu.vala"
	_g_object_unref0 (item);
#line 163 "../applets/core/dirmenu/dirmenu.vala"
	_g_dir_close0 (dir);
#line 163 "../applets/core/dirmenu/dirmenu.vala"
	(dir_list == NULL) ? NULL : (dir_list = (_g_slist_free__dirmenu_directory_sort_free0_ (dir_list), NULL));
#line 163 "../applets/core/dirmenu/dirmenu.vala"
	block2_data_unref (_data2_);
#line 163 "../applets/core/dirmenu/dirmenu.vala"
	_data2_ = NULL;
#line 163 "../applets/core/dirmenu/dirmenu.vala"
	return result;
#line 1407 "dirmenu.c"
}

static void
dirmenu_launch_terminal (Dirmenu* self,
                         const gchar* dir)
{
	gchar* command = NULL;
	gchar* true_dir = NULL;
	gchar* _tmp0_;
	ValaPanelToplevel* _tmp1_;
	ValaPanelToplevel* _tmp2_;
	GtkApplication* _tmp3_;
	GtkApplication* _tmp4_;
	gchar* _tmp5_ = NULL;
	GError* _inner_error0_ = NULL;
#line 165 "../applets/core/dirmenu/dirmenu.vala"
	g_return_if_fail (self != NULL);
#line 165 "../applets/core/dirmenu/dirmenu.vala"
	g_return_if_fail (dir != NULL);
#line 168 "../applets/core/dirmenu/dirmenu.vala"
	_tmp0_ = g_strdup (dir);
#line 168 "../applets/core/dirmenu/dirmenu.vala"
	true_dir = _tmp0_;
#line 169 "../applets/core/dirmenu/dirmenu.vala"
	_tmp1_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
#line 169 "../applets/core/dirmenu/dirmenu.vala"
	_tmp2_ = _tmp1_;
#line 169 "../applets/core/dirmenu/dirmenu.vala"
	_tmp3_ = gtk_window_get_application ((GtkWindow*) _tmp2_);
#line 169 "../applets/core/dirmenu/dirmenu.vala"
	_tmp4_ = _tmp3_;
#line 169 "../applets/core/dirmenu/dirmenu.vala"
	g_object_get ((GObject*) _tmp4_, "terminal-command", &_tmp5_, NULL);
#line 169 "../applets/core/dirmenu/dirmenu.vala"
	_g_free0 (command);
#line 169 "../applets/core/dirmenu/dirmenu.vala"
	command = _tmp5_;
#line 170 "../applets/core/dirmenu/dirmenu.vala"
	if (!g_path_is_absolute (dir)) {
#line 1447 "dirmenu.c"
		gchar* _tmp6_;
#line 171 "../applets/core/dirmenu/dirmenu.vala"
		_tmp6_ = realpath (dir, NULL);
#line 171 "../applets/core/dirmenu/dirmenu.vala"
		_g_free0 (true_dir);
#line 171 "../applets/core/dirmenu/dirmenu.vala"
		true_dir = _tmp6_;
#line 1455 "dirmenu.c"
	}
	{
		gchar** argv = NULL;
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gint argv_length1;
		gint _argv_size_;
		gchar** envp = NULL;
		gchar** _tmp10_;
		gchar** _tmp11_;
		const gchar* _tmp12_;
		gchar** _tmp13_;
		gchar** _tmp14_;
		gint envp_length1;
		gint _envp_size_;
		const gchar* _tmp15_;
#line 174 "../applets/core/dirmenu/dirmenu.vala"
		_tmp7_ = command;
#line 174 "../applets/core/dirmenu/dirmenu.vala"
		_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, " ", 0);
#line 174 "../applets/core/dirmenu/dirmenu.vala"
		argv = _tmp9_;
#line 174 "../applets/core/dirmenu/dirmenu.vala"
		argv_length1 = _vala_array_length (_tmp8_);
#line 174 "../applets/core/dirmenu/dirmenu.vala"
		_argv_size_ = argv_length1;
#line 175 "../applets/core/dirmenu/dirmenu.vala"
		_tmp11_ = _tmp10_ = g_get_environ ();
#line 175 "../applets/core/dirmenu/dirmenu.vala"
		_tmp12_ = true_dir;
#line 175 "../applets/core/dirmenu/dirmenu.vala"
		_tmp14_ = _tmp13_ = g_environ_setenv (_tmp11_, "PWD", _tmp12_, TRUE);
#line 175 "../applets/core/dirmenu/dirmenu.vala"
		envp = _tmp14_;
#line 175 "../applets/core/dirmenu/dirmenu.vala"
		envp_length1 = _vala_array_length (_tmp13_);
#line 175 "../applets/core/dirmenu/dirmenu.vala"
		_envp_size_ = envp_length1;
#line 176 "../applets/core/dirmenu/dirmenu.vala"
		_tmp15_ = true_dir;
#line 176 "../applets/core/dirmenu/dirmenu.vala"
		g_spawn_async (_tmp15_, argv, envp, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, &_inner_error0_);
#line 176 "../applets/core/dirmenu/dirmenu.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 176 "../applets/core/dirmenu/dirmenu.vala"
			envp = (_vala_array_free (envp, envp_length1, (GDestroyNotify) g_free), NULL);
#line 176 "../applets/core/dirmenu/dirmenu.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 1505 "dirmenu.c"
			goto __catch0_g_error;
		}
#line 172 "../applets/core/dirmenu/dirmenu.vala"
		envp = (_vala_array_free (envp, envp_length1, (GDestroyNotify) g_free), NULL);
#line 172 "../applets/core/dirmenu/dirmenu.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 1512 "dirmenu.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 172 "../applets/core/dirmenu/dirmenu.vala"
		e = _inner_error0_;
#line 172 "../applets/core/dirmenu/dirmenu.vala"
		_inner_error0_ = NULL;
#line 178 "../applets/core/dirmenu/dirmenu.vala"
		_tmp16_ = stderr;
#line 178 "../applets/core/dirmenu/dirmenu.vala"
		_tmp17_ = e;
#line 178 "../applets/core/dirmenu/dirmenu.vala"
		_tmp18_ = _tmp17_->message;
#line 178 "../applets/core/dirmenu/dirmenu.vala"
		fprintf (_tmp16_, "Cannot launch terminal: %s\n", _tmp18_);
#line 172 "../applets/core/dirmenu/dirmenu.vala"
		_g_error_free0 (e);
#line 1535 "dirmenu.c"
	}
	__finally0:
#line 172 "../applets/core/dirmenu/dirmenu.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../applets/core/dirmenu/dirmenu.vala"
		_g_free0 (true_dir);
#line 172 "../applets/core/dirmenu/dirmenu.vala"
		_g_free0 (command);
#line 172 "../applets/core/dirmenu/dirmenu.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 172 "../applets/core/dirmenu/dirmenu.vala"
		g_clear_error (&_inner_error0_);
#line 172 "../applets/core/dirmenu/dirmenu.vala"
		return;
#line 1550 "dirmenu.c"
	}
#line 165 "../applets/core/dirmenu/dirmenu.vala"
	_g_free0 (true_dir);
#line 165 "../applets/core/dirmenu/dirmenu.vala"
	_g_free0 (command);
#line 1556 "dirmenu.c"
}

static gboolean
dirmenu_real_button_release_event (GtkWidget* base,
                                   GdkEventButton* e)
{
	Dirmenu * self;
	gboolean result;
#line 180 "../applets/core/dirmenu/dirmenu.vala"
	self = (Dirmenu*) base;
#line 180 "../applets/core/dirmenu/dirmenu.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 182 "../applets/core/dirmenu/dirmenu.vala"
	if (e->button == ((guint) 2)) {
#line 1571 "dirmenu.c"
		const gchar* _tmp0_;
#line 183 "../applets/core/dirmenu/dirmenu.vala"
		_tmp0_ = self->priv->_dir_path;
#line 183 "../applets/core/dirmenu/dirmenu.vala"
		dirmenu_launch_terminal (self, _tmp0_);
#line 1577 "dirmenu.c"
	}
#line 184 "../applets/core/dirmenu/dirmenu.vala"
	result = FALSE;
#line 184 "../applets/core/dirmenu/dirmenu.vala"
	return result;
#line 1583 "dirmenu.c"
}

static GtkWidget*
dirmenu_real_get_settings_ui (ValaPanelApplet* base)
{
	Dirmenu * self;
	gchar** names = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint names_length1;
	gint _names_size_;
	gchar** keys = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint keys_length1;
	gint _keys_size_;
	ValaPanelConfiguratorType* types = NULL;
	ValaPanelConfiguratorType* _tmp8_;
	gint types_length1;
	gint _types_size_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GtkWidget* _tmp11_;
	GtkWidget* result;
#line 186 "../applets/core/dirmenu/dirmenu.vala"
	self = (Dirmenu*) base;
#line 188 "../applets/core/dirmenu/dirmenu.vala"
	_tmp0_ = g_strdup (_ ("Directory"));
#line 188 "../applets/core/dirmenu/dirmenu.vala"
	_tmp1_ = g_strdup (_ ("Label"));
#line 188 "../applets/core/dirmenu/dirmenu.vala"
	_tmp2_ = g_strdup (_ ("Icon"));
#line 188 "../applets/core/dirmenu/dirmenu.vala"
	_tmp3_ = g_new0 (gchar*, 3 + 1);
#line 188 "../applets/core/dirmenu/dirmenu.vala"
	_tmp3_[0] = _tmp0_;
#line 188 "../applets/core/dirmenu/dirmenu.vala"
	_tmp3_[1] = _tmp1_;
#line 188 "../applets/core/dirmenu/dirmenu.vala"
	_tmp3_[2] = _tmp2_;
#line 188 "../applets/core/dirmenu/dirmenu.vala"
	names = _tmp3_;
#line 188 "../applets/core/dirmenu/dirmenu.vala"
	names_length1 = 3;
#line 188 "../applets/core/dirmenu/dirmenu.vala"
	_names_size_ = names_length1;
#line 193 "../applets/core/dirmenu/dirmenu.vala"
	_tmp4_ = g_strdup (DIRMENU_DIR);
#line 193 "../applets/core/dirmenu/dirmenu.vala"
	_tmp5_ = g_strdup (DIRMENU_LABEL);
#line 193 "../applets/core/dirmenu/dirmenu.vala"
	_tmp6_ = g_strdup (DIRMENU_ICON);
#line 193 "../applets/core/dirmenu/dirmenu.vala"
	_tmp7_ = g_new0 (gchar*, 3 + 1);
#line 193 "../applets/core/dirmenu/dirmenu.vala"
	_tmp7_[0] = _tmp4_;
#line 193 "../applets/core/dirmenu/dirmenu.vala"
	_tmp7_[1] = _tmp5_;
#line 193 "../applets/core/dirmenu/dirmenu.vala"
	_tmp7_[2] = _tmp6_;
#line 193 "../applets/core/dirmenu/dirmenu.vala"
	keys = _tmp7_;
#line 193 "../applets/core/dirmenu/dirmenu.vala"
	keys_length1 = 3;
#line 193 "../applets/core/dirmenu/dirmenu.vala"
	_keys_size_ = keys_length1;
#line 198 "../applets/core/dirmenu/dirmenu.vala"
	_tmp8_ = g_new0 (ValaPanelConfiguratorType, 3);
#line 198 "../applets/core/dirmenu/dirmenu.vala"
	_tmp8_[0] = CONF_DIRECTORY;
#line 198 "../applets/core/dirmenu/dirmenu.vala"
	_tmp8_[1] = CONF_STR;
#line 198 "../applets/core/dirmenu/dirmenu.vala"
	_tmp8_[2] = CONF_FILE_ENTRY;
#line 198 "../applets/core/dirmenu/dirmenu.vala"
	types = _tmp8_;
#line 198 "../applets/core/dirmenu/dirmenu.vala"
	types_length1 = 3;
#line 198 "../applets/core/dirmenu/dirmenu.vala"
	_types_size_ = types_length1;
#line 203 "../applets/core/dirmenu/dirmenu.vala"
	_tmp9_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 203 "../applets/core/dirmenu/dirmenu.vala"
	_tmp10_ = _tmp9_;
#line 203 "../applets/core/dirmenu/dirmenu.vala"
	_tmp11_ = vala_panel_generic_cfg_widget (_tmp10_, names, keys, types, (guint) types_length1);
#line 203 "../applets/core/dirmenu/dirmenu.vala"
	result = _tmp11_;
#line 203 "../applets/core/dirmenu/dirmenu.vala"
	types = (g_free (types), NULL);
#line 203 "../applets/core/dirmenu/dirmenu.vala"
	keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 203 "../applets/core/dirmenu/dirmenu.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 203 "../applets/core/dirmenu/dirmenu.vala"
	return result;
#line 1684 "dirmenu.c"
}

Dirmenu*
dirmenu_construct (GType object_type)
{
	Dirmenu * self = NULL;
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	self = (Dirmenu*) g_object_new (object_type, NULL);
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	return self;
#line 1695 "dirmenu.c"
}

Dirmenu*
dirmenu_new (void)
{
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	return dirmenu_construct (TYPE_DIRMENU);
#line 1703 "dirmenu.c"
}

const gchar*
dirmenu_get_dir_path (Dirmenu* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../applets/core/dirmenu/dirmenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../applets/core/dirmenu/dirmenu.vala"
	_tmp0_ = self->priv->_dir_path;
#line 33 "../applets/core/dirmenu/dirmenu.vala"
	result = _tmp0_;
#line 33 "../applets/core/dirmenu/dirmenu.vala"
	return result;
#line 1719 "dirmenu.c"
}

void
dirmenu_set_dir_path (Dirmenu* self,
                      const gchar* value)
{
	gchar* old_value;
#line 33 "../applets/core/dirmenu/dirmenu.vala"
	g_return_if_fail (self != NULL);
#line 33 "../applets/core/dirmenu/dirmenu.vala"
	old_value = dirmenu_get_dir_path (self);
#line 33 "../applets/core/dirmenu/dirmenu.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1733 "dirmenu.c"
		gchar* _tmp0_;
#line 33 "../applets/core/dirmenu/dirmenu.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../applets/core/dirmenu/dirmenu.vala"
		_g_free0 (self->priv->_dir_path);
#line 33 "../applets/core/dirmenu/dirmenu.vala"
		self->priv->_dir_path = _tmp0_;
#line 33 "../applets/core/dirmenu/dirmenu.vala"
		g_object_notify_by_pspec ((GObject *) self, dirmenu_properties[DIRMENU_DIR_PATH_PROPERTY]);
#line 1743 "dirmenu.c"
	}
}

const gchar*
dirmenu_get_caption (Dirmenu* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../applets/core/dirmenu/dirmenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../applets/core/dirmenu/dirmenu.vala"
	_tmp0_ = self->priv->_caption;
#line 35 "../applets/core/dirmenu/dirmenu.vala"
	result = _tmp0_;
#line 35 "../applets/core/dirmenu/dirmenu.vala"
	return result;
#line 1760 "dirmenu.c"
}

void
dirmenu_set_caption (Dirmenu* self,
                     const gchar* value)
{
	gchar* old_value;
#line 35 "../applets/core/dirmenu/dirmenu.vala"
	g_return_if_fail (self != NULL);
#line 35 "../applets/core/dirmenu/dirmenu.vala"
	old_value = dirmenu_get_caption (self);
#line 35 "../applets/core/dirmenu/dirmenu.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1774 "dirmenu.c"
		gchar* _tmp0_;
#line 35 "../applets/core/dirmenu/dirmenu.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../applets/core/dirmenu/dirmenu.vala"
		_g_free0 (self->priv->_caption);
#line 35 "../applets/core/dirmenu/dirmenu.vala"
		self->priv->_caption = _tmp0_;
#line 35 "../applets/core/dirmenu/dirmenu.vala"
		g_object_notify_by_pspec ((GObject *) self, dirmenu_properties[DIRMENU_CAPTION_PROPERTY]);
#line 1784 "dirmenu.c"
	}
}

const gchar*
dirmenu_get_icon_name (Dirmenu* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "../applets/core/dirmenu/dirmenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../applets/core/dirmenu/dirmenu.vala"
	_tmp0_ = self->priv->_icon_name;
#line 37 "../applets/core/dirmenu/dirmenu.vala"
	result = _tmp0_;
#line 37 "../applets/core/dirmenu/dirmenu.vala"
	return result;
#line 1801 "dirmenu.c"
}

void
dirmenu_set_icon_name (Dirmenu* self,
                       const gchar* value)
{
	gchar* old_value;
#line 37 "../applets/core/dirmenu/dirmenu.vala"
	g_return_if_fail (self != NULL);
#line 37 "../applets/core/dirmenu/dirmenu.vala"
	old_value = dirmenu_get_icon_name (self);
#line 37 "../applets/core/dirmenu/dirmenu.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1815 "dirmenu.c"
		gchar* _tmp0_;
#line 37 "../applets/core/dirmenu/dirmenu.vala"
		_tmp0_ = g_strdup (value);
#line 37 "../applets/core/dirmenu/dirmenu.vala"
		_g_free0 (self->priv->_icon_name);
#line 37 "../applets/core/dirmenu/dirmenu.vala"
		self->priv->_icon_name = _tmp0_;
#line 37 "../applets/core/dirmenu/dirmenu.vala"
		g_object_notify_by_pspec ((GObject *) self, dirmenu_properties[DIRMENU_ICON_NAME_PROPERTY]);
#line 1825 "dirmenu.c"
	}
}

static void
dirmenu_directory_sort_copy (const DirmenuDirectorySort* self,
                             DirmenuDirectorySort* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	_tmp0_ = (*self).dirname;
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	_g_free0 ((*dest).dirname);
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	(*dest).dirname = _tmp1_;
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	_tmp2_ = (*self).collate_key;
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	_g_free0 ((*dest).collate_key);
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	(*dest).collate_key = _tmp3_;
#line 1853 "dirmenu.c"
}

static void
dirmenu_directory_sort_destroy (DirmenuDirectorySort* self)
{
#line 26 "../applets/core/dirmenu/dirmenu.vala"
	_g_free0 ((*self).dirname);
#line 27 "../applets/core/dirmenu/dirmenu.vala"
	_g_free0 ((*self).collate_key);
#line 1863 "dirmenu.c"
}

static DirmenuDirectorySort*
dirmenu_directory_sort_dup (const DirmenuDirectorySort* self)
{
	DirmenuDirectorySort* dup;
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	dup = g_new0 (DirmenuDirectorySort, 1);
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	dirmenu_directory_sort_copy (self, dup);
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	return dup;
#line 1876 "dirmenu.c"
}

static void
dirmenu_directory_sort_free (DirmenuDirectorySort* self)
{
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	dirmenu_directory_sort_destroy (self);
#line 24 "../applets/core/dirmenu/dirmenu.vala"
	g_free (self);
#line 1886 "dirmenu.c"
}

static GType
dirmenu_directory_sort_get_type_once (void)
{
	GType dirmenu_directory_sort_type_id;
	dirmenu_directory_sort_type_id = g_boxed_type_register_static ("DirmenuDirectorySort", (GBoxedCopyFunc) dirmenu_directory_sort_dup, (GBoxedFreeFunc) dirmenu_directory_sort_free);
	return dirmenu_directory_sort_type_id;
}

static GType
dirmenu_directory_sort_get_type (void)
{
	static volatile gsize dirmenu_directory_sort_type_id__once = 0;
	if (g_once_init_enter (&dirmenu_directory_sort_type_id__once)) {
		GType dirmenu_directory_sort_type_id;
		dirmenu_directory_sort_type_id = dirmenu_directory_sort_get_type_once ();
		g_once_init_leave (&dirmenu_directory_sort_type_id__once, dirmenu_directory_sort_type_id);
	}
	return dirmenu_directory_sort_type_id__once;
}

static void
dirmenu_class_init (DirmenuClass * klass,
                    gpointer klass_data)
{
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	dirmenu_parent_class = g_type_class_peek_parent (klass);
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	g_type_class_adjust_private_offset (klass, &Dirmenu_private_offset);
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) dirmenu_real_constructed;
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) dirmenu_real_button_release_event;
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	((ValaPanelAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (ValaPanelApplet*)) dirmenu_real_get_settings_ui;
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dirmenu_get_property;
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_dirmenu_set_property;
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	G_OBJECT_CLASS (klass)->finalize = dirmenu_finalize;
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIRMENU_DIR_PATH_PROPERTY, dirmenu_properties[DIRMENU_DIR_PATH_PROPERTY] = g_param_spec_string ("dir-path", "dir-path", "dir-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIRMENU_CAPTION_PROPERTY, dirmenu_properties[DIRMENU_CAPTION_PROPERTY] = g_param_spec_string ("caption", "caption", "caption", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIRMENU_ICON_NAME_PROPERTY, dirmenu_properties[DIRMENU_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1935 "dirmenu.c"
}

static void
dirmenu_instance_init (Dirmenu * self,
                       gpointer klass)
{
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	self->priv = dirmenu_get_instance_private (self);
#line 1944 "dirmenu.c"
}

static void
dirmenu_finalize (GObject * obj)
{
	Dirmenu * self;
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DIRMENU, Dirmenu);
#line 32 "../applets/core/dirmenu/dirmenu.vala"
	_g_free0 (self->priv->_dir_path);
#line 34 "../applets/core/dirmenu/dirmenu.vala"
	_g_free0 (self->priv->_caption);
#line 36 "../applets/core/dirmenu/dirmenu.vala"
	_g_free0 (self->priv->_icon_name);
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	G_OBJECT_CLASS (dirmenu_parent_class)->finalize (obj);
#line 1961 "dirmenu.c"
}

GType
dirmenu_get_type (void)
{
	return dirmenu_type_id;
}

GType
dirmenu_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (DirmenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dirmenu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Dirmenu), 0, (GInstanceInitFunc) dirmenu_instance_init, NULL };
	dirmenu_type_id = g_type_module_register_type (module, vala_panel_applet_get_type (), "Dirmenu", &g_define_type_info, 0);
	Dirmenu_private_offset = sizeof (DirmenuPrivate);
	return dirmenu_type_id;
}

static void
_vala_dirmenu_get_property (GObject * object,
                            guint property_id,
                            GValue * value,
                            GParamSpec * pspec)
{
	Dirmenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DIRMENU, Dirmenu);
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	switch (property_id) {
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		case DIRMENU_DIR_PATH_PROPERTY:
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		g_value_set_string (value, dirmenu_get_dir_path (self));
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		break;
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		case DIRMENU_CAPTION_PROPERTY:
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		g_value_set_string (value, dirmenu_get_caption (self));
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		break;
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		case DIRMENU_ICON_NAME_PROPERTY:
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		g_value_set_string (value, dirmenu_get_icon_name (self));
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		break;
#line 2007 "dirmenu.c"
		default:
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		break;
#line 2013 "dirmenu.c"
	}
}

static void
_vala_dirmenu_set_property (GObject * object,
                            guint property_id,
                            const GValue * value,
                            GParamSpec * pspec)
{
	Dirmenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DIRMENU, Dirmenu);
#line 22 "../applets/core/dirmenu/dirmenu.vala"
	switch (property_id) {
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		case DIRMENU_DIR_PATH_PROPERTY:
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		dirmenu_set_dir_path (self, g_value_get_string (value));
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		break;
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		case DIRMENU_CAPTION_PROPERTY:
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		dirmenu_set_caption (self, g_value_get_string (value));
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		break;
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		case DIRMENU_ICON_NAME_PROPERTY:
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		dirmenu_set_icon_name (self, g_value_get_string (value));
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		break;
#line 2045 "dirmenu.c"
		default:
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../applets/core/dirmenu/dirmenu.vala"
		break;
#line 2051 "dirmenu.c"
	}
}

void
g_io_dirmenu_load (GTypeModule* module)
{
#line 208 "../applets/core/dirmenu/dirmenu.vala"
	g_return_if_fail (module != NULL);
#line 208 "../applets/core/dirmenu/dirmenu.vala"
	dirmenu_register_type (module);
#line 211 "../applets/core/dirmenu/dirmenu.vala"
	g_io_extension_point_implement (VALA_PANEL_APPLET_EXTENSION_POINT, TYPE_DIRMENU, "org.valapanel.dirmenu", 10);
#line 2064 "dirmenu.c"
}

void
g_io_dirmenu_unload (GIOModule* module)
{
#line 214 "../applets/core/dirmenu/dirmenu.vala"
	g_return_if_fail (module != NULL);
#line 2072 "dirmenu.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

