/* wincmd.c generated by valac 0.56.17, the Vala compiler
 * generated from wincmd.vala, do not modify */

/*
 * vala-panel
 * Copyright (C) 2015 Konstantin Pugin <ria.freelander@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "wincmd.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "vala-panel.h"
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>
#include <libwnck/libwnck.h>
#include <gdk/gdkx.h>

#define WINCMD_KEY_LEFT "left-button-command"
#define WINCMD_KEY_MIDDLE "middle-button-command"
#define WINCMD_KEY_TOGGLE "toggle-iconify-and-shade"
#define WINCMD_KEY_ICON "icon"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef enum  {
	WINCMD_COMMAND_NONE = 0,
	WINCMD_COMMAND_ICONIFY = 1,
	WINCMD_COMMAND_SHADE = 2
} WincmdCommand;

#define WINCMD_TYPE_COMMAND (wincmd_command_get_type ())
enum  {
	WINCMD_0_PROPERTY,
	WINCMD_LEFT_BUTTON_COMMAND_PROPERTY,
	WINCMD_MIDDLE_BUTTON_COMMAND_PROPERTY,
	WINCMD_TOGGLE_ICONIFY_AND_SHADE_PROPERTY,
	WINCMD_ICON_PROPERTY,
	WINCMD_NUM_PROPERTIES
};
static GParamSpec* wincmd_properties[WINCMD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WincmdPrivate {
	GtkButton* button;
	GtkImage* image;
	gboolean toggle_state;
	WincmdCommand _left_button_command;
	WincmdCommand _middle_button_command;
	gboolean _toggle_iconify_and_shade;
	gchar* _icon;
};

static gint Wincmd_private_offset;
static gpointer wincmd_parent_class = NULL;
static GType wincmd_type_id = 0;

VALA_EXTERN GType wincmd_command_get_type (void) G_GNUC_CONST ;
static void wincmd_real_constructed (GObject* base);
VALA_EXTERN const gchar* wincmd_get_icon (Wincmd* self);
static void __lambda4_ (Wincmd* self);
static void wincmd_execute_command (Wincmd* self,
                             WincmdCommand command);
VALA_EXTERN WincmdCommand wincmd_get_left_button_command (Wincmd* self);
static void ___lambda4__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void __lambda5_ (Wincmd* self,
                 GParamSpec* pspec);
static void wincmd_update_icon (Wincmd* self);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static GtkWidget* wincmd_real_get_settings_ui (ValaPanelApplet* base);
VALA_EXTERN gboolean wincmd_get_toggle_iconify_and_shade (Wincmd* self);
static void wincmd_adjust_toggle_state (Wincmd* self);
static gboolean wincmd_real_button_release_event (GtkWidget* base,
                                           GdkEventButton* e);
VALA_EXTERN WincmdCommand wincmd_get_middle_button_command (Wincmd* self);
VALA_EXTERN void wincmd_set_left_button_command (Wincmd* self,
                                     WincmdCommand value);
VALA_EXTERN void wincmd_set_middle_button_command (Wincmd* self,
                                       WincmdCommand value);
VALA_EXTERN void wincmd_set_toggle_iconify_and_shade (Wincmd* self,
                                          gboolean value);
VALA_EXTERN void wincmd_set_icon (Wincmd* self,
                      const gchar* value);
static void wincmd_finalize (GObject * obj);
static void _vala_wincmd_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_wincmd_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
wincmd_get_instance_private (Wincmd* self)
{
	return G_STRUCT_MEMBER_P (self, Wincmd_private_offset);
}

static GType
wincmd_command_get_type_once (void)
{
	static const GEnumValue values[] = {{WINCMD_COMMAND_NONE, "WINCMD_COMMAND_NONE", "none"}, {WINCMD_COMMAND_ICONIFY, "WINCMD_COMMAND_ICONIFY", "iconify"}, {WINCMD_COMMAND_SHADE, "WINCMD_COMMAND_SHADE", "shade"}, {0, NULL, NULL}};
	GType wincmd_command_type_id;
	wincmd_command_type_id = g_enum_register_static ("WincmdCommand", values);
	return wincmd_command_type_id;
}

GType
wincmd_command_get_type (void)
{
	static volatile gsize wincmd_command_type_id__once = 0;
	if (g_once_init_enter (&wincmd_command_type_id__once)) {
		GType wincmd_command_type_id;
		wincmd_command_type_id = wincmd_command_get_type_once ();
		g_once_init_leave (&wincmd_command_type_id__once, wincmd_command_type_id);
	}
	return wincmd_command_type_id__once;
}

static void
__lambda4_ (Wincmd* self)
{
	WincmdCommand _tmp0_;
#line 66 "../applets/wnck/wincmd/wincmd.vala"
	_tmp0_ = self->priv->_left_button_command;
#line 66 "../applets/wnck/wincmd/wincmd.vala"
	wincmd_execute_command (self, _tmp0_);
#line 163 "wincmd.c"
}

static void
___lambda4__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 65 "../applets/wnck/wincmd/wincmd.vala"
	__lambda4_ ((Wincmd*) self);
#line 172 "wincmd.c"
}

static void
__lambda5_ (Wincmd* self,
            GParamSpec* pspec)
{
#line 68 "../applets/wnck/wincmd/wincmd.vala"
	g_return_if_fail (pspec != NULL);
#line 69 "../applets/wnck/wincmd/wincmd.vala"
	wincmd_update_icon (self);
#line 183 "wincmd.c"
}

static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 68 "../applets/wnck/wincmd/wincmd.vala"
	__lambda5_ ((Wincmd*) self, pspec);
#line 193 "wincmd.c"
}

static void
wincmd_real_constructed (GObject* base)
{
	Wincmd * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GAction* _tmp2_;
	GtkButton* _tmp3_;
	GtkImage* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* _tmp12_;
	GIcon* gicon = NULL;
	GThemedIcon* _tmp13_;
	GtkImage* _tmp20_;
	GIcon* _tmp21_;
	ValaPanelToplevel* _tmp22_;
	ValaPanelToplevel* _tmp23_;
	GtkButton* _tmp24_;
	GtkImage* _tmp25_;
	GtkButton* _tmp26_;
	GtkImage* _tmp27_;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkImage* _tmp30_;
	GtkButton* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 46 "../applets/wnck/wincmd/wincmd.vala"
	self = (Wincmd*) base;
#line 48 "../applets/wnck/wincmd/wincmd.vala"
	_tmp0_ = vala_panel_applet_get_action_group ((ValaPanelApplet*) self);
#line 48 "../applets/wnck/wincmd/wincmd.vala"
	_tmp1_ = _tmp0_;
#line 48 "../applets/wnck/wincmd/wincmd.vala"
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) _tmp1_, VALA_PANEL_APPLET_ACTION_CONFIGURE);
#line 48 "../applets/wnck/wincmd/wincmd.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL, TRUE);
#line 49 "../applets/wnck/wincmd/wincmd.vala"
	_tmp3_ = (GtkButton*) gtk_button_new ();
#line 49 "../applets/wnck/wincmd/wincmd.vala"
	g_object_ref_sink (_tmp3_);
#line 49 "../applets/wnck/wincmd/wincmd.vala"
	_g_object_unref0 (self->priv->button);
#line 49 "../applets/wnck/wincmd/wincmd.vala"
	self->priv->button = _tmp3_;
#line 50 "../applets/wnck/wincmd/wincmd.vala"
	_tmp4_ = (GtkImage*) gtk_image_new ();
#line 50 "../applets/wnck/wincmd/wincmd.vala"
	g_object_ref_sink (_tmp4_);
#line 50 "../applets/wnck/wincmd/wincmd.vala"
	_g_object_unref0 (self->priv->image);
#line 50 "../applets/wnck/wincmd/wincmd.vala"
	self->priv->image = _tmp4_;
#line 51 "../applets/wnck/wincmd/wincmd.vala"
	_tmp5_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 51 "../applets/wnck/wincmd/wincmd.vala"
	_tmp6_ = _tmp5_;
#line 51 "../applets/wnck/wincmd/wincmd.vala"
	g_settings_bind (_tmp6_, WINCMD_KEY_LEFT, (GObject*) self, WINCMD_KEY_LEFT, G_SETTINGS_BIND_GET);
#line 52 "../applets/wnck/wincmd/wincmd.vala"
	_tmp7_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 52 "../applets/wnck/wincmd/wincmd.vala"
	_tmp8_ = _tmp7_;
#line 52 "../applets/wnck/wincmd/wincmd.vala"
	g_settings_bind (_tmp8_, WINCMD_KEY_MIDDLE, (GObject*) self, WINCMD_KEY_MIDDLE, G_SETTINGS_BIND_GET);
#line 53 "../applets/wnck/wincmd/wincmd.vala"
	_tmp9_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 53 "../applets/wnck/wincmd/wincmd.vala"
	_tmp10_ = _tmp9_;
#line 53 "../applets/wnck/wincmd/wincmd.vala"
	g_settings_bind (_tmp10_, WINCMD_KEY_TOGGLE, (GObject*) self, WINCMD_KEY_TOGGLE, G_SETTINGS_BIND_GET);
#line 54 "../applets/wnck/wincmd/wincmd.vala"
	_tmp11_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 54 "../applets/wnck/wincmd/wincmd.vala"
	_tmp12_ = _tmp11_;
#line 54 "../applets/wnck/wincmd/wincmd.vala"
	g_settings_bind (_tmp12_, WINCMD_KEY_ICON, (GObject*) self, WINCMD_KEY_ICON, G_SETTINGS_BIND_GET);
#line 55 "../applets/wnck/wincmd/wincmd.vala"
	_tmp13_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("preferences-desktop-wallpaper-symbolic");
#line 55 "../applets/wnck/wincmd/wincmd.vala"
	gicon = (GIcon*) _tmp13_;
#line 282 "wincmd.c"
	{
		GIcon* _tmp14_ = NULL;
		const gchar* _tmp15_;
		GIcon* _tmp16_;
		GIcon* _tmp17_;
#line 57 "../applets/wnck/wincmd/wincmd.vala"
		_tmp15_ = self->priv->_icon;
#line 57 "../applets/wnck/wincmd/wincmd.vala"
		_tmp16_ = g_icon_new_for_string (_tmp15_, &_inner_error0_);
#line 57 "../applets/wnck/wincmd/wincmd.vala"
		_tmp14_ = _tmp16_;
#line 57 "../applets/wnck/wincmd/wincmd.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 296 "wincmd.c"
			goto __catch0_g_error;
		}
#line 57 "../applets/wnck/wincmd/wincmd.vala"
		_tmp17_ = _tmp14_;
#line 57 "../applets/wnck/wincmd/wincmd.vala"
		_tmp14_ = NULL;
#line 57 "../applets/wnck/wincmd/wincmd.vala"
		_g_object_unref0 (gicon);
#line 57 "../applets/wnck/wincmd/wincmd.vala"
		gicon = _tmp17_;
#line 56 "../applets/wnck/wincmd/wincmd.vala"
		_g_object_unref0 (_tmp14_);
#line 309 "wincmd.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		FILE* _tmp18_;
		GThemedIcon* _tmp19_;
#line 56 "../applets/wnck/wincmd/wincmd.vala"
		g_clear_error (&_inner_error0_);
#line 59 "../applets/wnck/wincmd/wincmd.vala"
		_tmp18_ = stderr;
#line 59 "../applets/wnck/wincmd/wincmd.vala"
		fprintf (_tmp18_, "Default icon will be used\n");
#line 60 "../applets/wnck/wincmd/wincmd.vala"
		_tmp19_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("preferences-desktop-wallpaper-symbolic");
#line 60 "../applets/wnck/wincmd/wincmd.vala"
		_g_object_unref0 (gicon);
#line 60 "../applets/wnck/wincmd/wincmd.vala"
		gicon = (GIcon*) _tmp19_;
#line 328 "wincmd.c"
	}
	__finally0:
#line 56 "../applets/wnck/wincmd/wincmd.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../applets/wnck/wincmd/wincmd.vala"
		_g_object_unref0 (gicon);
#line 56 "../applets/wnck/wincmd/wincmd.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 56 "../applets/wnck/wincmd/wincmd.vala"
		g_clear_error (&_inner_error0_);
#line 56 "../applets/wnck/wincmd/wincmd.vala"
		return;
#line 341 "wincmd.c"
	}
#line 62 "../applets/wnck/wincmd/wincmd.vala"
	_tmp20_ = self->priv->image;
#line 62 "../applets/wnck/wincmd/wincmd.vala"
	_tmp21_ = gicon;
#line 62 "../applets/wnck/wincmd/wincmd.vala"
	_tmp22_ = vala_panel_applet_get_toplevel ((ValaPanelApplet*) self);
#line 62 "../applets/wnck/wincmd/wincmd.vala"
	_tmp23_ = _tmp22_;
#line 62 "../applets/wnck/wincmd/wincmd.vala"
	vala_panel_setup_icon (_tmp20_, _tmp21_, (GObject*) _tmp23_, -1);
#line 63 "../applets/wnck/wincmd/wincmd.vala"
	_tmp24_ = self->priv->button;
#line 63 "../applets/wnck/wincmd/wincmd.vala"
	_tmp25_ = self->priv->image;
#line 63 "../applets/wnck/wincmd/wincmd.vala"
	vala_panel_setup_button (_tmp24_, _tmp25_, NULL);
#line 64 "../applets/wnck/wincmd/wincmd.vala"
	_tmp26_ = self->priv->button;
#line 64 "../applets/wnck/wincmd/wincmd.vala"
	_tmp27_ = self->priv->image;
#line 64 "../applets/wnck/wincmd/wincmd.vala"
	gtk_button_set_image (_tmp26_, (GtkWidget*) _tmp27_);
#line 65 "../applets/wnck/wincmd/wincmd.vala"
	_tmp28_ = self->priv->button;
#line 65 "../applets/wnck/wincmd/wincmd.vala"
	g_signal_connect_object (_tmp28_, "clicked", (GCallback) ___lambda4__gtk_button_clicked, self, 0);
#line 68 "../applets/wnck/wincmd/wincmd.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) ___lambda5__g_object_notify, self, 0);
#line 71 "../applets/wnck/wincmd/wincmd.vala"
	_tmp29_ = self->priv->button;
#line 71 "../applets/wnck/wincmd/wincmd.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp29_);
#line 72 "../applets/wnck/wincmd/wincmd.vala"
	_tmp30_ = self->priv->image;
#line 72 "../applets/wnck/wincmd/wincmd.vala"
	gtk_widget_show ((GtkWidget*) _tmp30_);
#line 73 "../applets/wnck/wincmd/wincmd.vala"
	_tmp31_ = self->priv->button;
#line 73 "../applets/wnck/wincmd/wincmd.vala"
	gtk_widget_show ((GtkWidget*) _tmp31_);
#line 74 "../applets/wnck/wincmd/wincmd.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 46 "../applets/wnck/wincmd/wincmd.vala"
	_g_object_unref0 (gicon);
#line 387 "wincmd.c"
}

static GtkWidget*
wincmd_real_get_settings_ui (ValaPanelApplet* base)
{
	Wincmd * self;
	gchar** names = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint names_length1;
	gint _names_size_;
	gchar** keys = NULL;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint keys_length1;
	gint _keys_size_;
	ValaPanelConfiguratorType* types = NULL;
	ValaPanelConfiguratorType* _tmp4_;
	gint types_length1;
	gint _types_size_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GtkWidget* _tmp7_;
	GtkWidget* result;
#line 76 "../applets/wnck/wincmd/wincmd.vala"
	self = (Wincmd*) base;
#line 79 "../applets/wnck/wincmd/wincmd.vala"
	_tmp0_ = g_strdup (_ ("Alternately iconify/shade and raise"));
#line 79 "../applets/wnck/wincmd/wincmd.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 79 "../applets/wnck/wincmd/wincmd.vala"
	_tmp1_[0] = _tmp0_;
#line 79 "../applets/wnck/wincmd/wincmd.vala"
	names = _tmp1_;
#line 79 "../applets/wnck/wincmd/wincmd.vala"
	names_length1 = 1;
#line 79 "../applets/wnck/wincmd/wincmd.vala"
	_names_size_ = names_length1;
#line 82 "../applets/wnck/wincmd/wincmd.vala"
	_tmp2_ = g_strdup (WINCMD_KEY_TOGGLE);
#line 82 "../applets/wnck/wincmd/wincmd.vala"
	_tmp3_ = g_new0 (gchar*, 1 + 1);
#line 82 "../applets/wnck/wincmd/wincmd.vala"
	_tmp3_[0] = _tmp2_;
#line 82 "../applets/wnck/wincmd/wincmd.vala"
	keys = _tmp3_;
#line 82 "../applets/wnck/wincmd/wincmd.vala"
	keys_length1 = 1;
#line 82 "../applets/wnck/wincmd/wincmd.vala"
	_keys_size_ = keys_length1;
#line 85 "../applets/wnck/wincmd/wincmd.vala"
	_tmp4_ = g_new0 (ValaPanelConfiguratorType, 1);
#line 85 "../applets/wnck/wincmd/wincmd.vala"
	_tmp4_[0] = CONF_BOOL;
#line 85 "../applets/wnck/wincmd/wincmd.vala"
	types = _tmp4_;
#line 85 "../applets/wnck/wincmd/wincmd.vala"
	types_length1 = 1;
#line 85 "../applets/wnck/wincmd/wincmd.vala"
	_types_size_ = types_length1;
#line 88 "../applets/wnck/wincmd/wincmd.vala"
	_tmp5_ = vala_panel_applet_get_settings ((ValaPanelApplet*) self);
#line 88 "../applets/wnck/wincmd/wincmd.vala"
	_tmp6_ = _tmp5_;
#line 88 "../applets/wnck/wincmd/wincmd.vala"
	_tmp7_ = vala_panel_generic_cfg_widget (_tmp6_, names, keys, types, (guint) types_length1);
#line 88 "../applets/wnck/wincmd/wincmd.vala"
	result = _tmp7_;
#line 88 "../applets/wnck/wincmd/wincmd.vala"
	types = (g_free (types), NULL);
#line 88 "../applets/wnck/wincmd/wincmd.vala"
	keys = (_vala_array_free (keys, keys_length1, (GDestroyNotify) g_free), NULL);
#line 88 "../applets/wnck/wincmd/wincmd.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 88 "../applets/wnck/wincmd/wincmd.vala"
	return result;
#line 464 "wincmd.c"
}

static void
wincmd_update_icon (Wincmd* self)
{
	GIcon* gicon = NULL;
	GThemedIcon* _tmp0_;
	GtkImage* _tmp7_;
	GIcon* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 90 "../applets/wnck/wincmd/wincmd.vala"
	g_return_if_fail (self != NULL);
#line 92 "../applets/wnck/wincmd/wincmd.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("preferences-desktop-wallpaper-symbolic");
#line 92 "../applets/wnck/wincmd/wincmd.vala"
	gicon = (GIcon*) _tmp0_;
#line 481 "wincmd.c"
	{
		GIcon* _tmp1_ = NULL;
		const gchar* _tmp2_;
		GIcon* _tmp3_;
		GIcon* _tmp4_;
#line 94 "../applets/wnck/wincmd/wincmd.vala"
		_tmp2_ = self->priv->_icon;
#line 94 "../applets/wnck/wincmd/wincmd.vala"
		_tmp3_ = g_icon_new_for_string (_tmp2_, &_inner_error0_);
#line 94 "../applets/wnck/wincmd/wincmd.vala"
		_tmp1_ = _tmp3_;
#line 94 "../applets/wnck/wincmd/wincmd.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 495 "wincmd.c"
			goto __catch0_g_error;
		}
#line 94 "../applets/wnck/wincmd/wincmd.vala"
		_tmp4_ = _tmp1_;
#line 94 "../applets/wnck/wincmd/wincmd.vala"
		_tmp1_ = NULL;
#line 94 "../applets/wnck/wincmd/wincmd.vala"
		_g_object_unref0 (gicon);
#line 94 "../applets/wnck/wincmd/wincmd.vala"
		gicon = _tmp4_;
#line 93 "../applets/wnck/wincmd/wincmd.vala"
		_g_object_unref0 (_tmp1_);
#line 508 "wincmd.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		FILE* _tmp5_;
		GThemedIcon* _tmp6_;
#line 93 "../applets/wnck/wincmd/wincmd.vala"
		g_clear_error (&_inner_error0_);
#line 96 "../applets/wnck/wincmd/wincmd.vala"
		_tmp5_ = stderr;
#line 96 "../applets/wnck/wincmd/wincmd.vala"
		fprintf (_tmp5_, "Default icon will be used\n");
#line 97 "../applets/wnck/wincmd/wincmd.vala"
		_tmp6_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("preferences-desktop-wallpaper-symbolic");
#line 97 "../applets/wnck/wincmd/wincmd.vala"
		_g_object_unref0 (gicon);
#line 97 "../applets/wnck/wincmd/wincmd.vala"
		gicon = (GIcon*) _tmp6_;
#line 527 "wincmd.c"
	}
	__finally0:
#line 93 "../applets/wnck/wincmd/wincmd.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 93 "../applets/wnck/wincmd/wincmd.vala"
		_g_object_unref0 (gicon);
#line 93 "../applets/wnck/wincmd/wincmd.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 93 "../applets/wnck/wincmd/wincmd.vala"
		g_clear_error (&_inner_error0_);
#line 93 "../applets/wnck/wincmd/wincmd.vala"
		return;
#line 540 "wincmd.c"
	}
#line 99 "../applets/wnck/wincmd/wincmd.vala"
	_tmp7_ = self->priv->image;
#line 99 "../applets/wnck/wincmd/wincmd.vala"
	_tmp8_ = gicon;
#line 99 "../applets/wnck/wincmd/wincmd.vala"
	gtk_image_set_from_gicon (_tmp7_, _tmp8_, (GtkIconSize) GTK_ICON_SIZE_INVALID);
#line 90 "../applets/wnck/wincmd/wincmd.vala"
	_g_object_unref0 (gicon);
#line 550 "wincmd.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 103 "../applets/wnck/wincmd/wincmd.vala"
	return self ? g_object_ref (self) : NULL;
#line 558 "wincmd.c"
}

static void
wincmd_execute_command (Wincmd* self,
                        WincmdCommand command)
{
	WnckScreen* scr = NULL;
	WnckScreen* _tmp0_;
	WnckScreen* _tmp1_;
	WnckWorkspace* desk = NULL;
	WnckScreen* _tmp9_;
	WnckWorkspace* _tmp10_;
	WnckWorkspace* _tmp11_;
	WnckScreen* _tmp12_;
	GList* _tmp13_;
#line 101 "../applets/wnck/wincmd/wincmd.vala"
	g_return_if_fail (self != NULL);
#line 103 "../applets/wnck/wincmd/wincmd.vala"
	_tmp0_ = wnck_screen_get_default ();
#line 103 "../applets/wnck/wincmd/wincmd.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 103 "../applets/wnck/wincmd/wincmd.vala"
	scr = _tmp1_;
#line 105 "../applets/wnck/wincmd/wincmd.vala"
	if (command == WINCMD_COMMAND_ICONIFY) {
#line 584 "wincmd.c"
		GdkX11Screen* screen = NULL;
		GdkScreen* _tmp2_;
		GdkX11Screen* _tmp3_;
		GdkAtom atom = (GdkAtom) 0U;
		GdkX11Screen* _tmp4_;
#line 107 "../applets/wnck/wincmd/wincmd.vala"
		_tmp2_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 107 "../applets/wnck/wincmd/wincmd.vala"
		_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gdk_x11_screen_get_type ()) ? ((GdkX11Screen*) _tmp2_) : NULL);
#line 107 "../applets/wnck/wincmd/wincmd.vala"
		screen = _tmp3_;
#line 108 "../applets/wnck/wincmd/wincmd.vala"
		atom = gdk_atom_intern ("_NET_SHOWING_DESKTOP", FALSE);
#line 112 "../applets/wnck/wincmd/wincmd.vala"
		_tmp4_ = screen;
#line 112 "../applets/wnck/wincmd/wincmd.vala"
		if (gdk_x11_screen_supports_net_wm_hint (_tmp4_, atom)) {
#line 602 "wincmd.c"
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
			gboolean showing_desktop = FALSE;
			WnckScreen* _tmp8_;
#line 114 "../applets/wnck/wincmd/wincmd.vala"
			_tmp7_ = self->priv->_toggle_iconify_and_shade;
#line 114 "../applets/wnck/wincmd/wincmd.vala"
			if (!_tmp7_) {
#line 114 "../applets/wnck/wincmd/wincmd.vala"
				_tmp6_ = TRUE;
#line 614 "wincmd.c"
			} else {
#line 114 "../applets/wnck/wincmd/wincmd.vala"
				_tmp6_ = !self->priv->toggle_state;
#line 618 "wincmd.c"
			}
#line 114 "../applets/wnck/wincmd/wincmd.vala"
			if (_tmp6_) {
#line 114 "../applets/wnck/wincmd/wincmd.vala"
				_tmp5_ = TRUE;
#line 624 "wincmd.c"
			} else {
#line 114 "../applets/wnck/wincmd/wincmd.vala"
				_tmp5_ = FALSE;
#line 628 "wincmd.c"
			}
#line 114 "../applets/wnck/wincmd/wincmd.vala"
			showing_desktop = _tmp5_;
#line 115 "../applets/wnck/wincmd/wincmd.vala"
			_tmp8_ = scr;
#line 115 "../applets/wnck/wincmd/wincmd.vala"
			wnck_screen_toggle_showing_desktop (_tmp8_, showing_desktop);
#line 116 "../applets/wnck/wincmd/wincmd.vala"
			wincmd_adjust_toggle_state (self);
#line 117 "../applets/wnck/wincmd/wincmd.vala"
			_g_object_unref0 (screen);
#line 117 "../applets/wnck/wincmd/wincmd.vala"
			_g_object_unref0 (scr);
#line 117 "../applets/wnck/wincmd/wincmd.vala"
			return;
#line 644 "wincmd.c"
		}
#line 105 "../applets/wnck/wincmd/wincmd.vala"
		_g_object_unref0 (screen);
#line 648 "wincmd.c"
	}
#line 120 "../applets/wnck/wincmd/wincmd.vala"
	_tmp9_ = scr;
#line 120 "../applets/wnck/wincmd/wincmd.vala"
	_tmp10_ = wnck_screen_get_active_workspace (_tmp9_);
#line 120 "../applets/wnck/wincmd/wincmd.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 120 "../applets/wnck/wincmd/wincmd.vala"
	desk = _tmp11_;
#line 121 "../applets/wnck/wincmd/wincmd.vala"
	_tmp12_ = scr;
#line 121 "../applets/wnck/wincmd/wincmd.vala"
	_tmp13_ = wnck_screen_get_windows (_tmp12_);
#line 662 "wincmd.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 121 "../applets/wnck/wincmd/wincmd.vala"
		window_collection = _tmp13_;
#line 121 "../applets/wnck/wincmd/wincmd.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 670 "wincmd.c"
			WnckWindow* _tmp14_;
			WnckWindow* window = NULL;
#line 121 "../applets/wnck/wincmd/wincmd.vala"
			_tmp14_ = _g_object_ref0 ((WnckWindow*) window_it->data);
#line 121 "../applets/wnck/wincmd/wincmd.vala"
			window = _tmp14_;
#line 677 "wincmd.c"
			{
				WnckWindow* _tmp15_;
				WnckWorkspace* _tmp16_;
#line 123 "../applets/wnck/wincmd/wincmd.vala"
				_tmp15_ = window;
#line 123 "../applets/wnck/wincmd/wincmd.vala"
				_tmp16_ = desk;
#line 123 "../applets/wnck/wincmd/wincmd.vala"
				if (wnck_window_is_visible_on_workspace (_tmp15_, _tmp16_)) {
#line 125 "../applets/wnck/wincmd/wincmd.vala"
					switch (command) {
#line 125 "../applets/wnck/wincmd/wincmd.vala"
						case WINCMD_COMMAND_NONE:
#line 691 "wincmd.c"
						{
#line 128 "../applets/wnck/wincmd/wincmd.vala"
							break;
#line 695 "wincmd.c"
						}
#line 125 "../applets/wnck/wincmd/wincmd.vala"
						case WINCMD_COMMAND_ICONIFY:
#line 699 "wincmd.c"
						{
							gboolean _tmp17_ = FALSE;
							gboolean _tmp18_;
#line 130 "../applets/wnck/wincmd/wincmd.vala"
							_tmp18_ = self->priv->_toggle_iconify_and_shade;
#line 130 "../applets/wnck/wincmd/wincmd.vala"
							if (!_tmp18_) {
#line 130 "../applets/wnck/wincmd/wincmd.vala"
								_tmp17_ = TRUE;
#line 709 "wincmd.c"
							} else {
#line 130 "../applets/wnck/wincmd/wincmd.vala"
								_tmp17_ = !self->priv->toggle_state;
#line 713 "wincmd.c"
							}
#line 130 "../applets/wnck/wincmd/wincmd.vala"
							if (_tmp17_) {
#line 717 "wincmd.c"
								WnckWindow* _tmp19_;
#line 131 "../applets/wnck/wincmd/wincmd.vala"
								_tmp19_ = window;
#line 131 "../applets/wnck/wincmd/wincmd.vala"
								wnck_window_minimize (_tmp19_);
#line 723 "wincmd.c"
							} else {
								WnckWindow* _tmp20_;
#line 133 "../applets/wnck/wincmd/wincmd.vala"
								_tmp20_ = window;
#line 133 "../applets/wnck/wincmd/wincmd.vala"
								wnck_window_unminimize (_tmp20_, gtk_get_current_event_time ());
#line 730 "wincmd.c"
							}
#line 134 "../applets/wnck/wincmd/wincmd.vala"
							break;
#line 734 "wincmd.c"
						}
#line 125 "../applets/wnck/wincmd/wincmd.vala"
						case WINCMD_COMMAND_SHADE:
#line 738 "wincmd.c"
						{
							gboolean _tmp21_ = FALSE;
							gboolean _tmp22_;
#line 136 "../applets/wnck/wincmd/wincmd.vala"
							_tmp22_ = self->priv->_toggle_iconify_and_shade;
#line 136 "../applets/wnck/wincmd/wincmd.vala"
							if (!_tmp22_) {
#line 136 "../applets/wnck/wincmd/wincmd.vala"
								_tmp21_ = TRUE;
#line 748 "wincmd.c"
							} else {
#line 136 "../applets/wnck/wincmd/wincmd.vala"
								_tmp21_ = !self->priv->toggle_state;
#line 752 "wincmd.c"
							}
#line 136 "../applets/wnck/wincmd/wincmd.vala"
							if (_tmp21_) {
#line 756 "wincmd.c"
								WnckWindow* _tmp23_;
#line 137 "../applets/wnck/wincmd/wincmd.vala"
								_tmp23_ = window;
#line 137 "../applets/wnck/wincmd/wincmd.vala"
								wnck_window_shade (_tmp23_);
#line 762 "wincmd.c"
							} else {
								WnckWindow* _tmp24_;
#line 139 "../applets/wnck/wincmd/wincmd.vala"
								_tmp24_ = window;
#line 139 "../applets/wnck/wincmd/wincmd.vala"
								wnck_window_unshade (_tmp24_);
#line 769 "wincmd.c"
							}
#line 140 "../applets/wnck/wincmd/wincmd.vala"
							break;
#line 773 "wincmd.c"
						}
						default:
#line 125 "../applets/wnck/wincmd/wincmd.vala"
						break;
#line 778 "wincmd.c"
					}
				}
#line 121 "../applets/wnck/wincmd/wincmd.vala"
				_g_object_unref0 (window);
#line 783 "wincmd.c"
			}
		}
	}
#line 144 "../applets/wnck/wincmd/wincmd.vala"
	wincmd_adjust_toggle_state (self);
#line 101 "../applets/wnck/wincmd/wincmd.vala"
	_g_object_unref0 (desk);
#line 101 "../applets/wnck/wincmd/wincmd.vala"
	_g_object_unref0 (scr);
#line 793 "wincmd.c"
}

static void
wincmd_adjust_toggle_state (Wincmd* self)
{
	gboolean _tmp0_;
#line 146 "../applets/wnck/wincmd/wincmd.vala"
	g_return_if_fail (self != NULL);
#line 148 "../applets/wnck/wincmd/wincmd.vala"
	_tmp0_ = self->priv->_toggle_iconify_and_shade;
#line 148 "../applets/wnck/wincmd/wincmd.vala"
	if (_tmp0_) {
#line 149 "../applets/wnck/wincmd/wincmd.vala"
		self->priv->toggle_state = !self->priv->toggle_state;
#line 808 "wincmd.c"
	} else {
#line 150 "../applets/wnck/wincmd/wincmd.vala"
		self->priv->toggle_state = TRUE;
#line 812 "wincmd.c"
	}
}

static gboolean
wincmd_real_button_release_event (GtkWidget* base,
                                  GdkEventButton* e)
{
	Wincmd * self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 152 "../applets/wnck/wincmd/wincmd.vala"
	self = (Wincmd*) base;
#line 152 "../applets/wnck/wincmd/wincmd.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 154 "../applets/wnck/wincmd/wincmd.vala"
	if (e->button == ((guint) 2)) {
#line 829 "wincmd.c"
		WincmdCommand _tmp1_;
#line 154 "../applets/wnck/wincmd/wincmd.vala"
		_tmp1_ = self->priv->_middle_button_command;
#line 154 "../applets/wnck/wincmd/wincmd.vala"
		_tmp0_ = _tmp1_ != WINCMD_COMMAND_NONE;
#line 835 "wincmd.c"
	} else {
#line 154 "../applets/wnck/wincmd/wincmd.vala"
		_tmp0_ = FALSE;
#line 839 "wincmd.c"
	}
#line 154 "../applets/wnck/wincmd/wincmd.vala"
	if (_tmp0_) {
#line 843 "wincmd.c"
		WincmdCommand _tmp2_;
#line 156 "../applets/wnck/wincmd/wincmd.vala"
		_tmp2_ = self->priv->_middle_button_command;
#line 156 "../applets/wnck/wincmd/wincmd.vala"
		wincmd_execute_command (self, _tmp2_);
#line 157 "../applets/wnck/wincmd/wincmd.vala"
		result = TRUE;
#line 157 "../applets/wnck/wincmd/wincmd.vala"
		return result;
#line 853 "wincmd.c"
	}
#line 159 "../applets/wnck/wincmd/wincmd.vala"
	result = FALSE;
#line 159 "../applets/wnck/wincmd/wincmd.vala"
	return result;
#line 859 "wincmd.c"
}

Wincmd*
wincmd_construct (GType object_type)
{
	Wincmd * self = NULL;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	self = (Wincmd*) g_object_new (object_type, NULL);
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	return self;
#line 870 "wincmd.c"
}

Wincmd*
wincmd_new (void)
{
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	return wincmd_construct (TYPE_WINCMD);
#line 878 "wincmd.c"
}

WincmdCommand
wincmd_get_left_button_command (Wincmd* self)
{
	WincmdCommand result;
#line 38 "../applets/wnck/wincmd/wincmd.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../applets/wnck/wincmd/wincmd.vala"
	result = self->priv->_left_button_command;
#line 38 "../applets/wnck/wincmd/wincmd.vala"
	return result;
#line 891 "wincmd.c"
}

void
wincmd_set_left_button_command (Wincmd* self,
                                WincmdCommand value)
{
	WincmdCommand old_value;
#line 38 "../applets/wnck/wincmd/wincmd.vala"
	g_return_if_fail (self != NULL);
#line 38 "../applets/wnck/wincmd/wincmd.vala"
	old_value = wincmd_get_left_button_command (self);
#line 38 "../applets/wnck/wincmd/wincmd.vala"
	if (old_value != value) {
#line 38 "../applets/wnck/wincmd/wincmd.vala"
		self->priv->_left_button_command = value;
#line 38 "../applets/wnck/wincmd/wincmd.vala"
		g_object_notify_by_pspec ((GObject *) self, wincmd_properties[WINCMD_LEFT_BUTTON_COMMAND_PROPERTY]);
#line 909 "wincmd.c"
	}
}

WincmdCommand
wincmd_get_middle_button_command (Wincmd* self)
{
	WincmdCommand result;
#line 40 "../applets/wnck/wincmd/wincmd.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../applets/wnck/wincmd/wincmd.vala"
	result = self->priv->_middle_button_command;
#line 40 "../applets/wnck/wincmd/wincmd.vala"
	return result;
#line 923 "wincmd.c"
}

void
wincmd_set_middle_button_command (Wincmd* self,
                                  WincmdCommand value)
{
	WincmdCommand old_value;
#line 40 "../applets/wnck/wincmd/wincmd.vala"
	g_return_if_fail (self != NULL);
#line 40 "../applets/wnck/wincmd/wincmd.vala"
	old_value = wincmd_get_middle_button_command (self);
#line 40 "../applets/wnck/wincmd/wincmd.vala"
	if (old_value != value) {
#line 40 "../applets/wnck/wincmd/wincmd.vala"
		self->priv->_middle_button_command = value;
#line 40 "../applets/wnck/wincmd/wincmd.vala"
		g_object_notify_by_pspec ((GObject *) self, wincmd_properties[WINCMD_MIDDLE_BUTTON_COMMAND_PROPERTY]);
#line 941 "wincmd.c"
	}
}

gboolean
wincmd_get_toggle_iconify_and_shade (Wincmd* self)
{
	gboolean result;
#line 42 "../applets/wnck/wincmd/wincmd.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../applets/wnck/wincmd/wincmd.vala"
	result = self->priv->_toggle_iconify_and_shade;
#line 42 "../applets/wnck/wincmd/wincmd.vala"
	return result;
#line 955 "wincmd.c"
}

void
wincmd_set_toggle_iconify_and_shade (Wincmd* self,
                                     gboolean value)
{
	gboolean old_value;
#line 42 "../applets/wnck/wincmd/wincmd.vala"
	g_return_if_fail (self != NULL);
#line 42 "../applets/wnck/wincmd/wincmd.vala"
	old_value = wincmd_get_toggle_iconify_and_shade (self);
#line 42 "../applets/wnck/wincmd/wincmd.vala"
	if (old_value != value) {
#line 42 "../applets/wnck/wincmd/wincmd.vala"
		self->priv->_toggle_iconify_and_shade = value;
#line 42 "../applets/wnck/wincmd/wincmd.vala"
		g_object_notify_by_pspec ((GObject *) self, wincmd_properties[WINCMD_TOGGLE_ICONIFY_AND_SHADE_PROPERTY]);
#line 973 "wincmd.c"
	}
}

const gchar*
wincmd_get_icon (Wincmd* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "../applets/wnck/wincmd/wincmd.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../applets/wnck/wincmd/wincmd.vala"
	_tmp0_ = self->priv->_icon;
#line 44 "../applets/wnck/wincmd/wincmd.vala"
	result = _tmp0_;
#line 44 "../applets/wnck/wincmd/wincmd.vala"
	return result;
#line 990 "wincmd.c"
}

void
wincmd_set_icon (Wincmd* self,
                 const gchar* value)
{
	gchar* old_value;
#line 44 "../applets/wnck/wincmd/wincmd.vala"
	g_return_if_fail (self != NULL);
#line 44 "../applets/wnck/wincmd/wincmd.vala"
	old_value = wincmd_get_icon (self);
#line 44 "../applets/wnck/wincmd/wincmd.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1004 "wincmd.c"
		gchar* _tmp0_;
#line 44 "../applets/wnck/wincmd/wincmd.vala"
		_tmp0_ = g_strdup (value);
#line 44 "../applets/wnck/wincmd/wincmd.vala"
		_g_free0 (self->priv->_icon);
#line 44 "../applets/wnck/wincmd/wincmd.vala"
		self->priv->_icon = _tmp0_;
#line 44 "../applets/wnck/wincmd/wincmd.vala"
		g_object_notify_by_pspec ((GObject *) self, wincmd_properties[WINCMD_ICON_PROPERTY]);
#line 1014 "wincmd.c"
	}
}

static void
wincmd_class_init (WincmdClass * klass,
                   gpointer klass_data)
{
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	wincmd_parent_class = g_type_class_peek_parent (klass);
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	g_type_class_adjust_private_offset (klass, &Wincmd_private_offset);
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	((GObjectClass *) klass)->constructed = (void (*) (GObject*)) wincmd_real_constructed;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	((ValaPanelAppletClass *) klass)->get_settings_ui = (GtkWidget* (*) (ValaPanelApplet*)) wincmd_real_get_settings_ui;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) wincmd_real_button_release_event;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_wincmd_get_property;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_wincmd_set_property;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	G_OBJECT_CLASS (klass)->finalize = wincmd_finalize;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINCMD_LEFT_BUTTON_COMMAND_PROPERTY, wincmd_properties[WINCMD_LEFT_BUTTON_COMMAND_PROPERTY] = g_param_spec_enum ("left-button-command", "left-button-command", "left-button-command", WINCMD_TYPE_COMMAND, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINCMD_MIDDLE_BUTTON_COMMAND_PROPERTY, wincmd_properties[WINCMD_MIDDLE_BUTTON_COMMAND_PROPERTY] = g_param_spec_enum ("middle-button-command", "middle-button-command", "middle-button-command", WINCMD_TYPE_COMMAND, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINCMD_TOGGLE_ICONIFY_AND_SHADE_PROPERTY, wincmd_properties[WINCMD_TOGGLE_ICONIFY_AND_SHADE_PROPERTY] = g_param_spec_boolean ("toggle-iconify-and-shade", "toggle-iconify-and-shade", "toggle-iconify-and-shade", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WINCMD_ICON_PROPERTY, wincmd_properties[WINCMD_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1046 "wincmd.c"
}

static void
wincmd_instance_init (Wincmd * self,
                      gpointer klass)
{
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	self->priv = wincmd_get_instance_private (self);
#line 1055 "wincmd.c"
}

static void
wincmd_finalize (GObject * obj)
{
	Wincmd * self;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WINCMD, Wincmd);
#line 34 "../applets/wnck/wincmd/wincmd.vala"
	_g_object_unref0 (self->priv->button);
#line 35 "../applets/wnck/wincmd/wincmd.vala"
	_g_object_unref0 (self->priv->image);
#line 43 "../applets/wnck/wincmd/wincmd.vala"
	_g_free0 (self->priv->_icon);
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	G_OBJECT_CLASS (wincmd_parent_class)->finalize (obj);
#line 1072 "wincmd.c"
}

GType
wincmd_get_type (void)
{
	return wincmd_type_id;
}

GType
wincmd_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (WincmdClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wincmd_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Wincmd), 0, (GInstanceInitFunc) wincmd_instance_init, NULL };
	wincmd_type_id = g_type_module_register_type (module, vala_panel_applet_get_type (), "Wincmd", &g_define_type_info, 0);
	Wincmd_private_offset = sizeof (WincmdPrivate);
	return wincmd_type_id;
}

static void
_vala_wincmd_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Wincmd * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WINCMD, Wincmd);
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	switch (property_id) {
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		case WINCMD_LEFT_BUTTON_COMMAND_PROPERTY:
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		g_value_set_enum (value, wincmd_get_left_button_command (self));
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		break;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		case WINCMD_MIDDLE_BUTTON_COMMAND_PROPERTY:
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		g_value_set_enum (value, wincmd_get_middle_button_command (self));
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		break;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		case WINCMD_TOGGLE_ICONIFY_AND_SHADE_PROPERTY:
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		g_value_set_boolean (value, wincmd_get_toggle_iconify_and_shade (self));
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		break;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		case WINCMD_ICON_PROPERTY:
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		g_value_set_string (value, wincmd_get_icon (self));
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		break;
#line 1124 "wincmd.c"
		default:
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		break;
#line 1130 "wincmd.c"
	}
}

static void
_vala_wincmd_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Wincmd * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WINCMD, Wincmd);
#line 22 "../applets/wnck/wincmd/wincmd.vala"
	switch (property_id) {
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		case WINCMD_LEFT_BUTTON_COMMAND_PROPERTY:
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		wincmd_set_left_button_command (self, g_value_get_enum (value));
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		break;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		case WINCMD_MIDDLE_BUTTON_COMMAND_PROPERTY:
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		wincmd_set_middle_button_command (self, g_value_get_enum (value));
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		break;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		case WINCMD_TOGGLE_ICONIFY_AND_SHADE_PROPERTY:
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		wincmd_set_toggle_iconify_and_shade (self, g_value_get_boolean (value));
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		break;
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		case WINCMD_ICON_PROPERTY:
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		wincmd_set_icon (self, g_value_get_string (value));
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		break;
#line 1168 "wincmd.c"
		default:
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../applets/wnck/wincmd/wincmd.vala"
		break;
#line 1174 "wincmd.c"
	}
}

void
g_io_wincmd_load (GTypeModule* module)
{
#line 164 "../applets/wnck/wincmd/wincmd.vala"
	g_return_if_fail (module != NULL);
#line 164 "../applets/wnck/wincmd/wincmd.vala"
	wincmd_register_type (module);
#line 167 "../applets/wnck/wincmd/wincmd.vala"
	g_io_extension_point_implement (VALA_PANEL_APPLET_EXTENSION_POINT, TYPE_WINCMD, "org.valapanel.wincmd", 10);
#line 1187 "wincmd.c"
}

void
g_io_wincmd_unload (GIOModule* module)
{
#line 170 "../applets/wnck/wincmd/wincmd.vala"
	g_return_if_fail (module != NULL);
#line 1195 "wincmd.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

